{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvAppAnimatedIcon.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvAppAnimatedIcon;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, ExtCtrls;

type
  TJvAppAnimatedIcon = class(TComponent)
  private
    FActive: boolean;
    FDelay: cardinal;
    FImgList: TImageList;
    FTimer:TTimer;
    FNumber:Integer;
    procedure SetActive(const Value: boolean);
    procedure SetDelay(const Value: cardinal);
    procedure SetImgList(const Value: TImageList);
    procedure Animate(Sender: TObject);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Icons:TImageList read FImgList write SetImgList;
    property Active:boolean read FActive write SetActive;
    property Delay:cardinal read FDelay write SetDelay default 100;
  end;

implementation

{**************************************************}
constructor TJvAppAnimatedIcon.Create(AOwner: TComponent);
begin
   inherited;
   FNumber:=0;
   FDelay:=100;
   FTimer:=TTimer.Create(self);
   FTimer.OnTimer:=Animate;
   FTimer.Interval:=FDelay;
   FTimer.Enabled:=Factive;
end;
{**************************************************}
destructor TJvAppAnimatedIcon.Destroy;
begin
   FTimer.free;
   inherited;
end;
{**************************************************}
procedure TJvAppAnimatedIcon.Animate(Sender: TObject);
begin
   if (FImglist<>nil)and(FImgList.Count<>0) then
   begin
      FNumber:=(FNumber+1)mod FimgList.count;
      FimgList.GetIcon(Fnumber,Application.Icon);
   end;
end;
{**************************************************}
procedure TJvAppAnimatedIcon.SetActive(const Value: boolean);
begin
   FActive := Value;
   FTimer.enabled:=FActive;
end;
{**************************************************}
procedure TJvAppAnimatedIcon.SetDelay(const Value: cardinal);
begin
   FDelay := Value;
   FTimer.interval:=FDelay;
end;
{**************************************************}
procedure TJvAppAnimatedIcon.SetImgList(const Value: TImageList);
begin
   FImgList:=Value;
end;
{**************************************************}

end.
