{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvDiskPrompt.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvDiskPrompt;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvHSetup, JvCommonDialogD, JvBaseDlg, JvTypes;

type
  TJvDiskPrompt = class(TJvCommonDialogD)
  private
    FPathToSource: string;
    FTagFile: string;
    FPath: string;
    FFileSought: string;
    FDiskName: string;
    Fstyle: TDiskstyles;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property DiskName:string read FDiskName write FDiskName;
    property PathToSource:string read FPathToSource write FPathToSource;
    property FileSought:string read FFileSought write FFileSought;
    property TagFile:string read FTagFile write FTagFile;
    property NewPath:string read FPath write FPath;
    property style:TDiskstyles read Fstyle write Fstyle;
    function Execute:TDiskRes;override;
  end;

implementation

{**************************************************}
constructor TJvDiskPrompt.Create(AOwner: TComponent);
begin
   inherited;
   if Aowner is TWinControl then
   begin
      FDiskName:='';
      FPathToSource:='';
      FFileSought:='';
      FTagFile:='';
      FPath:='';
      Fstyle:=[];
   end;
end;
{**************************************************}
function TJvDiskPrompt.Execute: TDiskRes;
var
   Sty:DWord;
   required:PDword;
   res : array [0..255] of char;
begin
   result:=dsError;
   Sty:=0;
   if idfCheckFirst in Fstyle then Sty:=Sty or idf_CheckFirst;
   if idfNoBeep in Fstyle then Sty:=Sty or idf_NoBeep;
   if idfNoBrowse in Fstyle then Sty:=Sty or idf_NoBrowse;
   if idfNoCompressed in Fstyle then Sty:=Sty or idf_NoCompressed;
   if idfNoDetails in Fstyle then Sty:=Sty or idf_NoDetails;
   if idfNoForeground in Fstyle then Sty:=Sty or idf_NoForeground;
   if idfNoSkip in Fstyle then Sty:=Sty or idf_NoSkip;
   if idfOemDisk in Fstyle then Sty:=Sty or idf_OemDisk;
   if idfWarnIfSkip in Fstyle then Sty:=Sty or idf_WarnIfSkip;

   Required:=new(PDWord);

   if @FSetupPromptForDisk<>nil then
   begin
      case FSetupPromptForDisk(Fhandle,Pchar(Ftitle),PChar(FDiskName),
           PChar(FPathToSource),PCHar(FFileSought),PChar(FTagFile),sty,res,sizeof(res),Required) of
           DPROMPT_SUCCESS: begin
                               FPath:=StrPas(res);
                               result:=dsSuccess;
                            end;
           DPROMPT_CANCEL: result:=dsCancel;
           DPROMPT_SKIPFILE : result:=dsSkipfile;
           else result:=dsError;
      end;
   end;
end;
{**************************************************}
end.
