{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFlashForm.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFlashForm;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls;

type
  TJvFlashForm = class(TComponent)
  private
    FEnabled:boolean;
    FDelay:Integer;
    Fti:TTimer;
    FFlashed:boolean;
    FHandle:HWND;
    procedure SetEnabled(En:Boolean);
    procedure SetDelay(de:integer);
    procedure OnTi(Sender: TObject);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Enabled:boolean read FEnabled write SetEnabled default false;
    property Delay:Integer read FDelay write SetDelay default 200;
  end;

implementation

{****************************************************}
constructor TJvFlashForm.Create(AOwner: TComponent);
begin
  inherited;
  FDelay := 200;
  FFlashed := false;
  FHandle := GetParentForm(TControl(AOwner)).Handle;

  FTi := TTimer.Create(self);
  FTI.OnTimer := OnTi;
  FTi.Enabled := FEnabled;
  FTi.Interval := FDelay;
end;
{****************************************************}
destructor TJvFlashForm.Destroy;
begin
  FlashWindow(Fhandle,false);
  FTi.Free;
  inherited;
end;
{****************************************************}
procedure TJvFlashForm.SetEnabled(En: Boolean);
begin
  FEnabled := en;
  if not(csDesigning in ComponentState) then
     Fti.Enabled:=en;
end;
{****************************************************}
procedure TJvFlashForm.SetDelay(de: integer);
begin
  FDelay := de;
  Fti.Interval := de;
end;
{****************************************************}
procedure TJvFlashForm.OnTi(Sender: TObject);
begin
  FFlashed := not(FFlashed);
  FlashWindow(FHandle,FFLashed);
end;
{****************************************************}
end.
