{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvId3v2.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvId3v2;

{
Not yet coded (really complicated)
 USLT  4.9
 SYLT  4.10
 COMM  4.11
 RVAD  4.12
 EQUA  4.13
 RVRB  4.14
 GEOB  4.16
 RJvF  4.19
 AENC  4.20
 POSS  4.22
 USER  4.23
 COMR  4.25
Total : 12

ignored:
 SYTC
 ENCR
 GRID
 PRIV
 LINK
 MLLT
}

{
 TJvId3v2
}

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, extctrls,
  Dialogs, JPEG, JvId3v2Types;

type
  TJvID3FileType = (ftUNKNOW,ftMPG,ftMPG1,ftMPG2,ftMPG3,ftMPG2_5,ftMPG_AAC,ftVQF,ftPCM);
  {$EXTERNALSYM TJvID3FileType}
  TJvID3MediaType = (mtUNKONW,mtDIG,mtDIG_ANALOG_TRANSFER,mtANA,mtANA_WAX_CYLINDER,mtANA_8_TRACK_TAPE,mtCD,
                     mtCD_ANALOG,mtCD_DDD,mtCD_ADD,mtCD_AAD,mtLASERDISC,mtLASERDISC_ANALOG_TRANSFER,mtTURNTABLE,
                     mtTURNTABLE_33,mtTURNTABLE_45,mtTURNTABLE_71,mtTURNTABLE_76,mtTURNTABLE_78,mtTURNTABLE_80,
                     mtMINIDISC,mtMINIDISC_ANALOG_TRANSFER,mtDAT,mtDAT_ANALOG_TRANSFER,mtDAT_48KHZ_16B,mtDAT_32KHZ_16B,
                     mtDAT_32KHZ_12B,mtDAT_44KHZ_16B,mtDAT_44KHZ_16B_WIDE,mtDCC,mtDCC_ANALOG_TRANSFER,mtDVD,
                     mtDVD_ANALOG_TRANSFER,mtTV,mtTV_PAL,mtTV_NTSC,mtTV_SECAM,
                     mtVID,mtVID_PAL,mtVID_NTSC,mtVID_SECAM,mtVID_VHS,mtVID_SVHS,mtVID_BETA,mtRAD,mtRAD_FM,
                     mtRAD_AM,mtRAD_LW,mtRAD_MW,mtTEL,mtTEL_ISDN,mtMC,mtMC_4,mtMC_9,mtMC_I,mtMC_II,mtMC_III,
                     mtMC_IV,mtREE,mtREE_9,mtREE_19,mtREE_38,mtREE_76,mtREE_I,mtREE_II,mtREE_III,mtREE_IV,
                     mtDAT_32KHZ_12B_4CH);
  {$EXTERNALSYM TJvID3MediaType}

  TJvId3Text = class(TPersistent)
  private
    FBPM: Integer;
    FAlbum: string;
    FComposer: TstringList;
    FDelay: Integer;
    FCopyright: string;
    FEncodedBy: string;
    FDate: string;
    FLyricist: TstringList;
    FFileType: TJvID3FileType;
    FTIme: string;
    FInitialKey: string;
    FContent: string;
    FSubTitle: string;
    FContentD: string;
    FLanguages: TstringList;
    FLength: string;
    FMediaType: TJvID3MediaType;
    FOriginal: string;
    FFileName: string;
    FOLyricists: TstringList;
    FOArtist: TstringList;
    FOwner: string;
    FOYear: string;
    FPerformers: TstringList;
    FConductor: string;
    FModified: string;
    FBand: string;
    FPart: string;
    FPublisher: string;
    FTrackNumber: string;
    FRecording: string;
    FInternet: string;
    FIOwner: string;
    FSize: Integer;
    FISRC: string;
    FEncoding: string;
    FYear: string;
    procedure ResetFields;
  protected
  public
     constructor Create;
     destructor Destroy;override;
  published
     property Album:string read FAlbum write FAlbum;
     property BPM:Integer read FBPM write FBPM;
     property Composer:TstringList read FComposer write FComposer;
     property Copyright:string read FCopyright write FCopyright;
     property Date:string read FDate write FDate;
     property PlaylistDelay:Integer read FDelay write FDelay;
     property EncodedBy:string read FEncodedBy write FEncodedBy;
     property Lyricists:TstringList read FLyricist write FLyricist;
     property FileType:TJvID3FileType read FFileType write FFileType;
     property Time:string read FTIme write FTime;
     property ContentGroup:string read FContent write FContent;
     property ContentDescription:string read FContentD write FContentD;
     property SubTitle:string read FSubTitle write FSubTitle;
     property InitialKey:string read FInitialKey write FInitialKey;
     property Languages:TstringList read FLanguages write FLanguages;
     property Length:string read FLength write FLength;
     property MediaType:TJvID3MediaType read FMediaType write FMediaType;
     property OriginalTitle:string read FOriginal write FOriginal;
     property OriginalFileName:string read FFileName write FFileName;
     property OriginalLyricists:TstringList read FOLyricists write FOLyricists;
     property OriginalArtist:TstringList read FOArtist write FOArtist;
     property OriginalReleaseYear:string read FOYear write FOYear;
     property FileOwner:string read FOwner write FOwner;
     property Performers:TstringList read FPerformers write FPerformers;
     property Band:string read FBand write FBand;
     property Conductor:string read FConductor write FConductor;
     property ModifiedBy:string read FModified write FModified;
     property PartOf:string read FPart write FPart;
     property Publisher:string read FPublisher write FPublisher;
     property TrackNumber:string read FTrackNumber write FTrackNumber;
     property recordingDate:string read FRecording write FRecording;
     property InternetRadioName:string read FInternet write FInternet;
     property InternetRadioOwner:string read FIOwner write FIOwner;
     property Size:Integer read FSize write FSize;
     property ISRC:string read FISRC write FISRC;
     property EncodingSoftware:string read FEncoding write FEncoding;
     property Year:string read FYear write FYear;
     property Content:string read FContent write FContent;
  end;

  TJvId3Web = class(TPersistent)
  private
    FAudio: string;
    FStation: string;
    FPublishers: string;
    FASource: string;
    FPayment: string;
    FLegal: string;
    FCommercial: string;
    FArtist: string;
    procedure ResetFields;
  protected
  public
  published
    property CommercialInfo:string read FCommercial write FCommercial;
    property LegalInfo:string read FLegal write FLegal;
    property OfficialAudio:string read FAudio write FAudio;
    property OfficialArtist:string read FArtist write FArtist;
    property OfficialAudioSource:string read FASource write FASource;
    property InternetRadioStation:string read FStation write FStation;
    property Payment:string read FPayment write FPayment;
    property Publishers:string read FPublishers write FPublishers;
  end;

  TJvID3UDText = class(TPersistent)
  private
    FCount: Integer;
    FItems: Integer;
    FDescription: string;
    FValue: string;
    FBidonI:Integer;
    Fstrings:TstringList;
    FDescriptions:TstringList;

    procedure ResetFields;
    procedure SetItem(const Value: integer);
    procedure AddItem(desc,Value:string);
  protected
  public
    constructor Create;
    destructor Destroy;override;
  published
    property ItemIndex:Integer read FItems write SetItem;
    property Description:string read FDescription write FDescription;
    property Value:string read FValue write FValue;
    property ItemCount:Integer read FCount write FBidonI;
  end;

  TJvID3UDUrl = class(TPersistent)
  private
    FCount: Integer;
    FItems: Integer;
    FDescription: string;
    FValue: string;
    FBidonI:Integer;
    Fstrings:TstringList;
    FDescriptions:TstringList;

    procedure ResetFields;
    procedure SetItem(const Value: integer);
    procedure AddItem(desc,Value:string);
  protected
  public
    constructor Create;
    destructor Destroy;override;
  published
    property ItemIndex:Integer read FItems write SetItem;
    property Description:string read FDescription write FDescription;
    property URL:string read FValue write FValue;
    property ItemCount:Integer read FCount write FBidonI;
  end;

  TJvIdPictures = class(TPersistent)
  private
    FMedia: TPicture;
    FLyricist: TPicture;
    FIcon: TPicture;
    FComposer: TPicture;
    FRLocation: TPicture;
    FOther: TPicture;
    FFish: TPicture;
    FCoverFront: TPicture;
    FBandLogo: TPicture;
    FConductor: TPicture;
    FPublisherLogo: TPicture;
    FDRecording: TPicture;
    FArtist: TPicture;
    FLeaflet: TPicture;
    FDPerformance: TPicture;
    FIllustration: TPicture;
    FBand: TPicture;
    FMove: TPicture;
    FCoverBack: TPicture;
    FOtherIcon: TPicture;
    FLeadArtist: TPicture;
    procedure SetArtist(const Value: TPicture);
    procedure SetBand(const Value: TPicture);
    procedure SetBandLogo(const Value: TPicture);
    procedure SetComposer(const Value: TPicture);
    procedure SetConductor(const Value: TPicture);
    procedure SetCoverBack(const Value: TPicture);
    procedure SetCoverFront(const Value: TPicture);
    procedure SetDRecording(const Value: TPicture);
    procedure SetFish(const Value: TPicture);
    procedure SetICon(const Value: TPicture);
    procedure SetIllustration(const Value: TPicture);
    procedure SetLeaflet(const Value: TPicture);
    procedure SetLocation(const Value: TPicture);
    procedure SetLyricist(const Value: TPicture);
    procedure SetMedia(const Value: TPicture);
    procedure SetMovie(const Value: TPicture);
    procedure SetOther(const Value: TPicture);
    procedure SetPerformance(const Value: TPicture);
    procedure SetPublisherLogo(const Value: TPicture);
    procedure SetOtherIcon(const Value: TPicture);
    procedure SetLeadArtist(const Value: TPicture);
  protected
  public
    constructor Create;
    destructor Destroy;override;
  published
    property Other:TPicture read FOther write SetOther;
    property FileIcon:TPicture read FIcon write SetICon;
    property OtherIcon:TPicture read FOtherIcon write SetOtherIcon;
    property CoverFront:TPicture read FCoverFront write SetCoverFront;
    property CoverBack:TPicture read FCoverBack write SetCoverBack;
    property Leaflet:TPicture read FLeaflet write SetLeaflet;
    property Media:TPicture read FMedia write SetMedia;
    property Artist:TPicture read FArtist write SetArtist;
    property Conductor:TPicture read FConductor write SetConductor;
    property Band:TPicture read FBand write SetBand;
    property Composer:TPicture read FComposer write SetComposer;
    property Lyricist:TPicture read FLyricist write SetLyricist;
    property recordingLocation:TPicture read FRLocation write SetLocation;
    property DuringRecording:TPicture read FDRecording write SetDRecording;
    property DuringPerformance:TPicture read FDPerformance write SetPerformance;
    property MovieCapture:TPicture read FMove write SetMovie;
    property ColouredFish:TPicture read FFish write SetFish;
    property Illustration:TPicture read FIllustration write SetIllustration;
    property BandLogo:TPicture read FBandLogo write SetBandLogo;
    property PublisherLogo:TPicture read FPublisherLogo write SetPublisherLogo;
    property LeadArtist:TPicture read FLeadArtist write SetLeadArtist;
  end;

  TJvIdPicturesDesc = class(TPersistent)
  private
    FLeaflet: string;
    FOtherIcon: string;
    FArtist: string;
    FIcon: string;
    FCoverFront: string;
    FPublisherLogo: string;
    FLeadArtist: string;
    FConductor: string;
    FDRecording: string;
    FBandLogo: string;
    FLyricist: string;
    FCoverBack: string;
    FIllustration: string;
    FBand: string;
    FMovie: string;
    FDPerformance: string;
    FComposer: string;
    FMedia: string;
    FFish: string;
    FRLocation: string;
    FOther: string;
  protected
  public
  published
    property Other:string read FOther write FOther;
    property FileIcon:string read FIcon write FICon;
    property OtherIcon:string read FOtherIcon write FOtherIcon;
    property CoverFront:string read FCoverFront write FCoverFront;
    property CoverBack:string read FCoverBack write FCoverBack;
    property Leaflet:string read FLeaflet write FLeaflet;
    property Media:string read FMedia write FMedia;
    property Artist:string read FArtist write FArtist;
    property Conductor:string read FConductor write FConductor;
    property Band:string read FBand write FBand;
    property Composer:string read FComposer write FComposer;
    property Lyricist:string read FLyricist write FLyricist;
    property recordingLocation:string read FRLocation write FRLocation;
    property DuringRecording:string read FDRecording write FDRecording;
    property DuringPerformance:string read FDPerformance write FDPerformance;
    property MovieCapture:string read FMovie write FMovie;
    property ColouredFish:string read FFish write FFish;
    property Illustration:string read FIllustration write FIllustration;
    property BandLogo:string read FBandLogo write FBandLogo;
    property PublisherLogo:string read FPublisherLogo write FPublisherLogo;
    property LeadArtist:string read FLeadArtist write FLeadArtist;
  end;

  TJvIdImages = class(TPErsistent)
  private
    FPictures: TJvIdPictures;
    FInfos: TJvIdPicturesDesc;
    procedure ResetFields;
  protected
  public
    constructor Create;
    destructor Destroy;override;
  published
    property Pictures:TJvIdPictures read FPictures write FPictures;
    property Infos:TJvIdPicturesDesc read FInfos write FInfos;
  end;

  TJvIdIpl = class(TPersistent)
  private
    FBidonI:Integer;
    FCount: Integer;
    FItems: Integer;
    FJob: string;
    FPerson: string;
    FJobs:TstringList;
    FPersons:TstringList;
    procedure SetItem(const Value: integer);
    procedure AddItem(Job,Person:string);
    procedure ResetFields;
  protected
  public
     constructor Create;
     destructor Destroy;override;
  published
    property ItemIndex:Integer read FItems write SetItem;
    property Job:string read FJob write FJob;
    property Person:string read FPerson write FPerson;
    property ItemCount:Integer read FCount write FBidonI;
  end;

  TJvId3Owner = class(TPersistent)
  private
    FSeller: string;
    FPrice: string;
    FDate: TDate;
    procedure ResetFields;
  protected
  public
  published
    property Price:string read FPrice write FPrice;
    property DatePurchased:TDate read FDate write FDate;
    property Seller:string read FSeller write FSeller;
  end;

  TJvId3Popularimeter = class(TPersistent)
  private
    FRating: byte;
    FCounter: Integer;
    FEmail: string;
    procedure ResetFields;
  protected
  public
  published
    property UserEmail:string read FEmail write FEmail;
    property Rating:byte read FRating write FRating;
    property Counter:Integer read FCounter write FCounter;
  end;

  TJvId3EventType = (etPADDING,etEND_OF_INITIAL_SILENCE,etINTRO_START,etMAINPART_START,
                     etOUTRO_START,etOUTRO_END,etVERSE_START,etREFRAIN_START,etINTERLUDE_START,
                     etTHEME_START,etVARIATION_START,etKEY_CHANGE,eTTime_CHANGE,etUNWANTED_NOISE,
                     etSUSTAINED_NOISE,etSUSTAINED_NOISE_END,etINTRO_END,etMAINPART_END,etVERSE_END,
                     etREFRAIN_END,etTHEME_END,etAUDIO_END,etFILE_END);
  {$EXTERNALSYM TJvId3EventType}

  TEventTiming = procedure (Sender: TObject;TimeStamp:Integer;EventType:TJvId3EventType) of object;

  TJvId3Events = record
    TimeStamp:Integer;
    EventType:TJvId3EventType;
  end;
  {$EXTERNALSYM TJvId3Events}

  TJvId3v2 = class(TComponent)
  private
    FEvents : array [0..1000] of TJvId3Events;
    FEventsCount:Integer;
    FEventsTiming:Integer;
    FLasTTime:Integer;

    FPresent: boolean;
    FVersion: real;
    FFileName: TFileName;
    FUnsynchro: boolean;
    FExperimental: boolean;
    FExtended: boolean;
    FSize:Integer;
    FId3Text: TJvId3Text;
    FWeb: TJvId3Web;
    FUDText: TJvID3UDText;
    FUDWeb: TJvID3UDUrl;
    FInvolved: TJvIdIpl;
    FImages: TJvIdImages;
    FOwner: TJvId3Owner;
    FCounter: cardinal;
    FPopula: TJvId3Popularimeter;
    FEventTiming: TEventTiming;

    //unusefull variables
    FBidonB : boolean;
    FBidonR : real;
    FBIdonI:Integer;
    FTagSize: Integer;
    
    procedure LoadFromFile(FileName:string);
    procedure SetFileName(const Value: TFileName);
    procedure ResetProp;
    procedure ReadAndUnsynchro(var source,dest:TStream;taille:integer);

    procedure ReadText(frame:TId3v2Frame;source:TStream);
    procedure ReadWeb(frame:TId3v2Frame;source:TStream);
    procedure ReadIpls(frame:TId3v2Frame;source:TStream);
    procedure ReadImg(frame:TId3v2Frame;source:TStream);
    procedure ReadCounter(frame:TId3v2Frame;source:TStream);
    procedure ReadPop(frame:TId3v2Frame;source:TStream);
    procedure ReadOwner(frame:TId3v2Frame;source:TStream);
    procedure ReadEvent(frame:TId3v2Frame;source:TStream);

    procedure SkipFrame(frame:TId3v2Frame;var source:TStream);
    function Iso639ToName(code:string):string;
  protected
  public
    MusicCDIdentifier:array [0..803] of byte;
    MusicCDIdentifierLength:Integer;
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property TagPresent:boolean read FPresent write FBidonB;
    property FileName:TFileName read FFileName write SetFileName;
    property Version:real read FVersion write FBidonR;
    property Unsynchronisation:boolean read FUnsynchro write FBidonB;
    property ExtendedHeader:boolean read FExtended write FBidonB;
    property Experimental:boolean read FExperimental write FBidonB;
    property Texts:TJvId3Text read FId3Text write FId3Text;
    property UserDefinedText:TJvID3UDText read FUDText write FUDText;
    property Web:TJvId3Web read FWeb write FWeb;
    property UserDefinedWeb:TJvID3UDUrl read FUDWeb write FUDWeb;
    property InvolvedPeople:TJvIdIpl read FInvolved write FInvolved;
    property Images:TJvIdImages read FImages write FImages;
    property PlayCounter:cardinal read FCounter write FCounter;
    property Owner:TJvId3Owner read FOwner write FOwner;
    property Popularimeter:TJvId3Popularimeter read FPopula write FPopula;
    property TagSize:Integer read FTagSize write FBidonI;

    procedure LoadFromStream(stream:TStream);
    procedure CheckEvent(CurrenTTime:integer);
    property OnEventTiming:TEventTiming read FEventTiming write FEventTiming;
  end;

implementation

///////////////////////////////////////////////////////////
// TJvId3v2
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvId3v2.CheckEvent(CurrenTTime: integer);
var
  i:Integer;
begin
   if (FEventsCount>0)and(Assigned(FEventTiming)) then
   begin
      if CurrenTTime<FLasTTime then
         FLasTTime:=0;
      for i:=0 to FEventsCount-1 do
         if FEvents[i].TimeStamp in [FLasTTime..CurrenTTime] then
            FEventTiming(self,FEvents[i].TimeStamp,FEvents[i].EventType);
   end;
   FLasTTime:=CurrenTTime;
end;
{******************************************************************************}
constructor TJvId3v2.Create(AOwner: TComponent);
begin
   inherited;
   FTagSize:=0;
   FLasTTime:=0;
   FPresent:=false;
   FId3Text:=TJvId3Text.Create;
   FWeb:=TJvId3Web.Create;
   FUDText:=TJvID3UDText.Create;
   FUDWeb:=TJvID3UDUrl.Create;
   FInvolved:=TJvIdIpl.Create;
   FImages:=TJvIdImages.Create;
   FOwner:=TJvId3Owner.Create;
   FPopula:=TJvId3Popularimeter.Create;
   ResetProp;
end;
{******************************************************************************}
destructor TJvId3v2.Destroy;
begin
   FId3Text.free;
   FWeb.free;
   FUDText.free;
   FUDWeb.free;
   FInvolved.free;
   FImages.free;
   FOwner.free;
   FPopula.free;
   inherited;
end;
{******************************************************************************}
function TJvId3v2.Iso639ToName(code: string): string;
begin
   code:=LowerCase(code);
   if code='aar' then result:='Afar'
   else if code='abk' then result:='Abkhazian'
   else if code='ace' then result:='Achinese'
   else if code='ach' then result:='Acoli'
   else if code='ada' then result:='Adangme'
   else if code='afa' then result:='Afro-Asiatic (Other)'
   else if code='afh' then result:='Afrihili'
   else if code='afr' then result:='Afrikaans'
   else if code='aka' then result:='Akan'
   else if code='akk' then result:='Akkadian'
   else if code='alb' then result:='Albanian'
   else if code='ale' then result:='Aleut'
   else if code='alg' then result:='Algonquian Languages'
   else if code='amh' then result:='Amharic'
   else if code='ang' then result:='English, Old (ca. 450-1100)'
   else if code='apa' then result:='Apache Languages'
   else if code='ara' then result:='Arabic'
   else if code='arc' then result:='Aramaic'
   else if code='arm' then result:='Armenian'
   else if code='arn' then result:='Araucanian'
   else if code='arp' then result:='Arapaho'
   else if code='art' then result:='Artificial (Other)'
   else if code='arw' then result:='Arawak'
   else if code='asm' then result:='Assamese'
   else if code='ath' then result:='Athapascan Languages'
   else if code='ava' then result:='Avaric'
   else if code='ave' then result:='Avestan'
   else if code='awa' then result:='Awadhi'
   else if code='aym' then result:='Aymara'
   else if code='aze' then result:='Azerbaijani'
   else if code='bad' then result:='Banda'
   else if code='bai' then result:='Bamileke Languages'
   else if code='bak' then result:='Bashkir'
   else if code='bal' then result:='Baluchi'
   else if code='bam' then result:='Bambara'
   else if code='ban' then result:='Balinese'
   else if code='baq' then result:='Basque'
   else if code='bas' then result:='Basa'
   else if code='bat' then result:='Baltic (Other)'
   else if code='bej' then result:='Beja'
   else if code='bel' then result:='Byelorussian'
   else if code='bem' then result:='Bemba'
   else if code='ben' then result:='Bengali'
   else if code='ber' then result:='Berber (Other)'
   else if code='bho' then result:='Bhojpuri'
   else if code='bih' then result:='Bihari'
   else if code='bik' then result:='Bikol'
   else if code='bin' then result:='Bini'
   else if code='bis' then result:='Bislama'
   else if code='bla' then result:='Siksika'
   else if code='bnt' then result:='Bantu (Other)'
   else if code='bod' then result:='Tibetan'
   else if code='bra' then result:='Braj'
   else if code='bre' then result:='Breton'
   else if code='bua' then result:='Buriat'
   else if code='bug' then result:='Buginese'
   else if code='bul' then result:='Bulgarian'
   else if code='bur' then result:='Burmese'
   else if code='cad' then result:='Caddo'
   else if code='cai' then result:='Central American Indian (Other)'
   else if code='car' then result:='Carib'
   else if code='cat' then result:='Catalan'
   else if code='cau' then result:='Caucasian (Other)'
   else if code='ceb' then result:='Cebuano'
   else if code='cel' then result:='Celtic (Other)'
   else if code='ces' then result:='Czech'
   else if code='cha' then result:='Chamorro'
   else if code='chb' then result:='Chibcha'
   else if code='che' then result:='Chechen'
   else if code='chg' then result:='Chagatai'
   else if code='chi' then result:='Chinese'
   else if code='chm' then result:='Mari'
   else if code='chn' then result:='Chinook jargon'
   else if code='cho' then result:='Choctaw'
   else if code='chr' then result:='Cherokee'
   else if code='chu' then result:='Church Slavic'
   else if code='chv' then result:='Chuvash'
   else if code='chy' then result:='Cheyenne'
   else if code='cop' then result:='Coptic'
   else if code='cor' then result:='Cornish'
   else if code='cos' then result:='Corsican'
   else if code='cpe' then result:='Creoles and Pidgins, English-based (Other)'
   else if code='cpf' then result:='Creoles and Pidgins, French-based (Other)'
   else if code='cpp' then result:='Creoles and Pidgins, Portuguese-based (Other)'
   else if code='cre' then result:='Cree'
   else if code='crp' then result:='Creoles and Pidgins (Other)'
   else if code='cus' then result:='Cushitic (Other)'
   else if code='cym' then result:='Welsh'
   else if code='cze' then result:='Czech'
   else if code='dak' then result:='Dakota'
   else if code='dan' then result:='Danish'
   else if code='del' then result:='Delaware'
   else if code='deu' then result:='German'
   else if code='din' then result:='Dinka'
   else if code='div' then result:='Divehi'
   else if code='doi' then result:='Dogri'
   else if code='dra' then result:='Dravidian (Other)'
   else if code='dua' then result:='Duala'
   else if code='dum' then result:='Dutch, Middle (ca. 1050-1350)'
   else if code='dut' then result:='Dutch'
   else if code='dyu' then result:='Dyula'
   else if code='dzo' then result:='Dzongkha'
   else if code='efi' then result:='Efik'
   else if code='egy' then result:='Egyptian (Ancient)'
   else if code='eka' then result:='Ekajuk'
   else if code='ell' then result:='Greek, Modern (1453-)'
   else if code='elx' then result:='Elamite'
   else if code='eng' then result:='English'
   else if code='enm' then result:='English, Middle (ca. 1100-1500)'
   else if code='epo' then result:='Esperanto'
   else if code='esk' then result:='Eskimo (Other)'
   else if code='esl' then result:='Spanish'
   else if code='est' then result:='Estonian'
   else if code='eus' then result:='Basque'
   else if code='ewe' then result:='Ewe'
   else if code='ewo' then result:='Ewondo'
   else if code='fan' then result:='Fang'
   else if code='fao' then result:='Faroese'
   else if code='fas' then result:='Persian'
   else if code='fat' then result:='Fanti'
   else if code='fij' then result:='Fijian'
   else if code='fin' then result:='Finnish'
   else if code='fiu' then result:='Finno-Ugrian (Other)'
   else if code='fon' then result:='Fon'
   else if code='fra' then result:='French'
   else if code='fre' then result:='French'
   else if code='frm' then result:='French, Middle (ca. 1400-1600)'
   else if code='fro' then result:='French, Old (842- ca. 1400)'
   else if code='fry' then result:='Frisian'
   else if code='ful' then result:='Fulah'
   else if code='gaa' then result:='Ga'
   else if code='gae' then result:='Gaelic (Scots)'
   else if code='gai' then result:='Irish'
   else if code='gay' then result:='Gayo'
   else if code='gdh' then result:='Gaelic (Scots)'
   else if code='gem' then result:='Germanic (Other)'
   else if code='geo' then result:='Georgian'
   else if code='ger' then result:='German'
   else if code='gez' then result:='Geez'
   else if code='gil' then result:='Gilbertese'
   else if code='glg' then result:='Gallegan'
   else if code='gmh' then result:='German, Middle High (ca. 1050-1500)'
   else if code='goh' then result:='German, Old High (ca. 750-1050)'
   else if code='gon' then result:='Gondi'
   else if code='got' then result:='Gothic'
   else if code='grb' then result:='Grebo'
   else if code='grc' then result:='Greek, Ancient (to 1453)'
   else if code='gre' then result:='Greek, Modern (1453-)'
   else if code='grn' then result:='Guarani'
   else if code='guj' then result:='Gujarati'
   else if code='hai' then result:='Haida'
   else if code='hau' then result:='Hausa'
   else if code='haw' then result:='Hawaiian'
   else if code='heb' then result:='Hebrew'
   else if code='her' then result:='Herero'
   else if code='hil' then result:='Hiligaynon'
   else if code='him' then result:='Himachali'
   else if code='hin' then result:='Hindi'
   else if code='hmo' then result:='Hiri Motu'
   else if code='hun' then result:='Hungarian'
   else if code='hup' then result:='Hupa'
   else if code='hye' then result:='Armenian'
   else if code='iba' then result:='Iban'
   else if code='ibo' then result:='Igbo'
   else if code='ice' then result:='Icelandic'
   else if code='ijo' then result:='Ijo'
   else if code='iku' then result:='Inuktitut'
   else if code='ilo' then result:='Iloko'
   else if code='ina' then result:='Interlingua (International Auxiliary language Association)'
   else if code='inc' then result:='Indic (Other)'
   else if code='ind' then result:='Indonesian'
   else if code='ine' then result:='Indo-European (Other)'
   else if code='ine' then result:='Interlingue'
   else if code='ipk' then result:='Inupiak'
   else if code='ira' then result:='Iranian (Other)'
   else if code='iri' then result:='Irish'
   else if code='iro' then result:='Iroquoian uages'
   else if code='isl' then result:='Icelandic'
   else if code='ita' then result:='Italian'
   else if code='jav' then result:='Javanese'
   else if code='jaw' then result:='Javanese'
   else if code='jpn' then result:='Japanese'
   else if code='jpr' then result:='Judeo-Persian'
   else if code='jrb' then result:='Judeo-Arabic'
   else if code='kaa' then result:='Kara-Kalpak'
   else if code='kab' then result:='Kabyle'
   else if code='kac' then result:='Kachin'
   else if code='kal' then result:='Greenlandic'
   else if code='kam' then result:='Kamba'
   else if code='kan' then result:='Kannada'
   else if code='kar' then result:='Karen'
   else if code='kas' then result:='Kashmiri'
   else if code='kat' then result:='Georgian'
   else if code='kau' then result:='Kanuri'
   else if code='kaw' then result:='Kawi'
   else if code='kaz' then result:='Kazakh'
   else if code='kha' then result:='Khasi'
   else if code='khi' then result:='Khoisan (Other)'
   else if code='khm' then result:='Khmer'
   else if code='kho' then result:='Khotanese'
   else if code='kik' then result:='Kikuyu'
   else if code='kin' then result:='Kinyarwanda'
   else if code='kir' then result:='Kirghiz'
   else if code='kok' then result:='Konkani'
   else if code='kom' then result:='Komi'
   else if code='kon' then result:='Kongo'
   else if code='kor' then result:='Korean'
   else if code='kpe' then result:='Kpelle'
   else if code='kro' then result:='Kru'
   else if code='kru' then result:='Kurukh'
   else if code='kua' then result:='Kuanyama'
   else if code='kum' then result:='Kumyk'
   else if code='kur' then result:='Kurdish'
   else if code='kus' then result:='Kusaie'
   else if code='kut' then result:='Kutenai'
   else if code='lad' then result:='Ladino'
   else if code='lah' then result:='Lahnda'
   else if code='lam' then result:='Lamba'
   else if code='lao' then result:='Lao'
   else if code='lat' then result:='Latin'
   else if code='lav' then result:='Latvian'
   else if code='lez' then result:='Lezghian'
   else if code='lin' then result:='Lingala'
   else if code='lit' then result:='Lithuanian'
   else if code='lol' then result:='Mongo'
   else if code='loz' then result:='Lozi'
   else if code='ltz' then result:='Letzeburgesch'
   else if code='lub' then result:='Luba-Katanga'
   else if code='lug' then result:='Ganda'
   else if code='lui' then result:='Luiseno'
   else if code='lun' then result:='Lunda'
   else if code='luo' then result:='Luo (Kenya and Tanzania)'
   else if code='mac' then result:='Macedonian'
   else if code='mad' then result:='Madurese'
   else if code='mag' then result:='Magahi'
   else if code='mah' then result:='Marshall'
   else if code='mai' then result:='Maithili'
   else if code='mak' then result:='Macedonian'
   else if code='mak' then result:='Makasar'
   else if code='mal' then result:='Malayalam'
   else if code='man' then result:='Mandingo'
   else if code='mao' then result:='Maori'
   else if code='map' then result:='Austronesian (Other)'
   else if code='mar' then result:='Marathi'
   else if code='mas' then result:='Masai'
   else if code='max' then result:='Manx'
   else if code='may' then result:='Malay'
   else if code='men' then result:='Mende'
   else if code='mga' then result:='Irish, Middle (900 - 1200)'
   else if code='mic' then result:='Micmac'
   else if code='min' then result:='Minangkabau'
   else if code='mis' then result:='Miscellaneous (Other)'
   else if code='mkh' then result:='Mon-Kmer (Other)'
   else if code='mlg' then result:='Malagasy'
   else if code='mlt' then result:='Maltese'
   else if code='mni' then result:='Manipuri'
   else if code='mno' then result:='Manobo Languages'
   else if code='moh' then result:='Mohawk'
   else if code='mol' then result:='Moldavian'
   else if code='mon' then result:='Mongolian'
   else if code='mos' then result:='Mossi'
   else if code='mri' then result:='Maori'
   else if code='msa' then result:='Malay'
   else if code='mul' then result:='Multiple Languages'
   else if code='mun' then result:='Munda Languages'
   else if code='mus' then result:='Creek'
   else if code='mwr' then result:='Marwari'
   else if code='mya' then result:='Burmese'
   else if code='myn' then result:='Mayan Languages'
   else if code='nah' then result:='Aztec'
   else if code='nai' then result:='North American Indian (Other)'
   else if code='nau' then result:='Nauru'
   else if code='nav' then result:='Navajo'
   else if code='nbl' then result:='Ndebele, South'
   else if code='nde' then result:='Ndebele, North'
   else if code='ndo' then result:='Ndongo'
   else if code='nep' then result:='Nepali'
   else if code='new' then result:='Newari'
   else if code='nic' then result:='Niger-Kordofanian (Other)'
   else if code='niu' then result:='Niuean'
   else if code='nla' then result:='Dutch'
   else if code='nno' then result:='Norwegian (Nynorsk)'
   else if code='non' then result:='Norse, Old'
   else if code='nor' then result:='Norwegian'
   else if code='nso' then result:='Sotho, Northern'
   else if code='nub' then result:='Nubian Languages'
   else if code='nya' then result:='Nyanja'
   else if code='nym' then result:='Nyamwezi'
   else if code='nyn' then result:='Nyankole'
   else if code='nyo' then result:='Nyoro'
   else if code='nzi' then result:='Nzima'
   else if code='oci' then result:='Langue d''Oc (post 1500)'
   else if code='oji' then result:='Ojibwa'
   else if code='ori' then result:='Oriya'
   else if code='orm' then result:='Oromo'
   else if code='osa' then result:='Osage'
   else if code='oss' then result:='Ossetic'
   else if code='ota' then result:='Turkish, Ottoman (1500 - 1928)'
   else if code='oto' then result:='Otomian Languages'
   else if code='paa' then result:='Papuan-Australian (Other)'
   else if code='pag' then result:='Pangasinan'
   else if code='pal' then result:='Pahlavi'
   else if code='pam' then result:='Pampanga'
   else if code='pan' then result:='Panjabi'
   else if code='pap' then result:='Papiamento'
   else if code='pau' then result:='Palauan'
   else if code='peo' then result:='Persian, Old (ca 600 - 400 B.C.)'
   else if code='per' then result:='Persian'
   else if code='phn' then result:='Phoenician'
   else if code='pli' then result:='Pali'
   else if code='pol' then result:='Polish'
   else if code='pon' then result:='Ponape'
   else if code='por' then result:='Portuguese'
   else if code='pra' then result:='Prakrit uages'
   else if code='pro' then result:='Provencal, Old (to 1500)'
   else if code='pus' then result:='Pushto'
   else if code='que' then result:='Quechua'
   else if code='raj' then result:='Rajasthani'
   else if code='rar' then result:='Rarotongan'
   else if code='roa' then result:='Romance (Other)'
   else if code='roh' then result:='Rhaeto-Romance'
   else if code='rom' then result:='Romany'
   else if code='ron' then result:='Romanian'
   else if code='rum' then result:='Romanian'
   else if code='run' then result:='Rundi'
   else if code='rus' then result:='Russian'
   else if code='sad' then result:='Sandawe'
   else if code='sag' then result:='Sango'
   else if code='sah' then result:='Yakut'
   else if code='sai' then result:='South American Indian (Other)'
   else if code='sal' then result:='Salishan Languages'
   else if code='sam' then result:='Samaritan Aramaic'
   else if code='san' then result:='Sanskrit'
   else if code='sco' then result:='Scots'
   else if code='scr' then result:='Serbo-Croatian'
   else if code='sel' then result:='Selkup'
   else if code='sem' then result:='Semitic (Other)'
   else if code='sga' then result:='Irish, Old (to 900)'
   else if code='shn' then result:='Shan'
   else if code='sid' then result:='Sidamo'
   else if code='sin' then result:='Singhalese'
   else if code='sio' then result:='Siouan Languages'
   else if code='sit' then result:='Sino-Tibetan (Other)'
   else if code='sla' then result:='Slavic (Other)'
   else if code='slk' then result:='Slovak'
   else if code='slo' then result:='Slovak'
   else if code='slv' then result:='Slovenian'
   else if code='smi' then result:='Sami Languages'
   else if code='smo' then result:='Samoan'
   else if code='sna' then result:='Shona'
   else if code='snd' then result:='Sindhi'
   else if code='sog' then result:='Sogdian'
   else if code='som' then result:='Somali'
   else if code='son' then result:='Songhai'
   else if code='sot' then result:='Sotho, Southern'
   else if code='spa' then result:='Spanish'
   else if code='sqi' then result:='Albanian'
   else if code='srd' then result:='Sardinian'
   else if code='srr' then result:='Serer'
   else if code='ssa' then result:='Nilo-Saharan (Other)'
   else if code='ssw' then result:='Siswant'
   else if code='ssw' then result:='Swazi'
   else if code='suk' then result:='Sukuma'
   else if code='sun' then result:='Sudanese'
   else if code='sus' then result:='Susu'
   else if code='sux' then result:='Sumerian'
   else if code='sve' then result:='Swedish'
   else if code='swa' then result:='Swahili'
   else if code='swe' then result:='Swedish'
   else if code='syr' then result:='Syriac'
   else if code='tah' then result:='Tahitian'
   else if code='tam' then result:='Tamil'
   else if code='tat' then result:='Tatar'
   else if code='tel' then result:='Telugu'
   else if code='tem' then result:='Timne'
   else if code='ter' then result:='Tereno'
   else if code='tgk' then result:='Tajik'
   else if code='tgl' then result:='Tagalog'
   else if code='tha' then result:='Thai'
   else if code='tib' then result:='Tibetan'
   else if code='tig' then result:='Tigre'
   else if code='tir' then result:='Tigrinya'
   else if code='tiv' then result:='Tivi'
   else if code='tli' then result:='Tlingit'
   else if code='tmh' then result:='Tamashek'
   else if code='tog' then result:='Tonga (Nyasa)'
   else if code='ton' then result:='Tonga (Tonga Islands)'
   else if code='tru' then result:='Truk'
   else if code='tsi' then result:='Tsimshian'
   else if code='tsn' then result:='Tswana'
   else if code='tso' then result:='Tsonga'
   else if code='tuk' then result:='Turkmen'
   else if code='tum' then result:='Tumbuka'
   else if code='tur' then result:='Turkish'
   else if code='tut' then result:='Altaic (Other)'
   else if code='twi' then result:='Twi'
   else if code='tyv' then result:='Tuvinian'
   else if code='uga' then result:='Ugaritic'
   else if code='uig' then result:='Uighur'
   else if code='ukr' then result:='Ukrainian'
   else if code='umb' then result:='Umbundu'
   else if code='und' then result:='Undetermined'
   else if code='urd' then result:='Urdu'
   else if code='uzb' then result:='Uzbek'
   else if code='vai' then result:='Vai'
   else if code='ven' then result:='Venda'
   else if code='vie' then result:='Vietnamese'
   else if code='vol' then result:='Volapk'
   else if code='vot' then result:='Votic'
   else if code='wak' then result:='Wakashan Languages'
   else if code='wal' then result:='Walamo'
   else if code='war' then result:='Waray'
   else if code='was' then result:='Washo'
   else if code='wel' then result:='Welsh'
   else if code='wen' then result:='Sorbian Languages'
   else if code='wol' then result:='Wolof'
   else if code='xho' then result:='Xhosa'
   else if code='yao' then result:='Yao'
   else if code='yap' then result:='Yap'
   else if code='yid' then result:='Yiddish'
   else if code='yor' then result:='Yoruba'
   else if code='zap' then result:='Zapotec'
   else if code='zen' then result:='Zenaga'
   else if code='zha' then result:='Zhuang'
   else if code='zho' then result:='Chinese'
   else if code='zul' then result:='Zulu'
   else if code='zun' then result:='Zuni'
   else result:='';
end;
{******************************************************************************}
procedure TJvId3v2.LoadFromFile(FileName: string);
var
   fich:TFileStream;
begin
   ResetProp;
   if fileexists(FileName) then
   begin
      fich:=TFileStream.Create(FileName,fmOpenRead or fmShareDenyWrite);
      LoadFromStream(fich);
      fich.free;
   end;
end;
{******************************************************************************}
procedure TJvId3v2.LoadFromStream(stream: TStream);
var
  header:TId3v2Header;
  frame:TId3v2Frame;
  tag:TStream;
begin
   FEventsCount:=0;
   ResetProp;

   stream.ReadBuffer(header,10);
   FPresent:=header.identifier='ID3';
   if FPresent then
   begin
      //Version
      FVersion:=(header.version and $00FF);
      FVersion:=FVersion+((header.version and $FF00)/256/100);

      //Flags
      FUnsynchro:=(header.flags and $80)<>0;
      FExtended:=(header.flags and $40)<>0;
      FExperimental:=(header.flags and $20)<>0;
      asm
         mov eax,header.size

         xor ecx,ecx
         mov cl,al
         shl ecx,7
         or cl,ah
         shl ecx,7
         shr eax,16
         or cl,al
         shl ecx,7
         or cl,ah

         mov header.size,ecx
      end;
      FSize:=header.size;
      FTagSize:=FSize;

      tag:=TMemoryStream.Create;
      ReadAndUnsynchro(stream,tag,header.size);

      //Read extended tag
      if FExtended then
      begin
          

      end;

      while (tag.size-tag.position>10) do
      begin
         tag.read(frame,10);
         asm
            mov ax,frame.flags
            mov dh,al
            mov al,ah
            mov ah,dh
            mov frame.flags,ax

            mov eax,frame.size
            mov cl,al
            shl ecx,8
            mov cl,ah
            shl ecx,8
            shr eax,16
            mov cl,al
            shl ecx,8
            mov cl,ah
            mov frame.size,ecx
         end;

         if frame.Id[0]='T' then
            ReadText(frame,tag)
         else if frame.Id[0]='W' then
            ReadWeb(frame,tag)
         else if frame.Id='IPLS' then
            ReadIpls(frame,tag)
         else if frame.Id='MCDI' then
         begin
            tag.Read(MusicCDIdentifier,frame.Size);
            MusicCDIdentifierLength:=frame.Size;
         end
         else if frame.Id='APIC' then
            ReadImg(frame,tag)
         else if frame.Id='PCNT' then
            ReadCounter(frame,tag)
         else if frame.Id='POPM' then
            ReadPop(frame,tag)
         else if frame.Id='OWNE' then
            ReadOwner(frame,tag)
         else if frame.Id='ETCO' then
            ReadEvent(frame,tag)
         else
            SkipFrame(frame,tag);

         //XXX
      end;

      tag.free;
  end;
end;
{******************************************************************************}
procedure TJvId3v2.ReadAndUnsynchro(var source, dest: TStream;taille : integer);
var
  i,j,cnt:Integer;
  buf:array [0..499] of byte;
  buf2:array [0..999] of byte;
begin
   while taille>0 do
   begin
      if taille>500 then
      begin
         cnt:=source.read(buf,500);
         if cnt<500 then taille:=0
         else taille:=taille-cnt;
      end
      else
      begin
         cnt:=source.read(buf,taille);
         taille:=0;
      end;
      j:=0;
      i:=0;
      while i<cnt do
      begin
         if buf[i]=$FF then
         begin
            if i+1<cnt then
            begin
                if buf[i+1]=$00 then
                begin
                   buf2[j]:=$FF;
                   inc(i);
                end
                else
                    buf2[j]:=$FF;
            end
            else
            begin
               inc(taille);
               source.position:=source.position-1;
            end;
         end
         else
           buf2[j]:=buf[i];
         inc(j);
         inc(i);
      end;
      dest.write(buf2,j);
   end;
   dest.position:=0;
end;
{******************************************************************************}
procedure TJvId3v2.ReadCounter(frame: TId3v2Frame; source: TStream);
begin
   if frame.Size>4 then FCounter:=0
   else
   begin
      source.read(FCounter,4);
      asm
         mov eax,FCounter
         mov cl,al
         shl ecx,8
         mov cl,ah
         shl ecx,8
         shr eax,16
         mov cl,al
         shl ecx,8
         mov cl,ah
         mov ebx,offset FCounter
         mov [ebx],ecx
      end;
   end;
end;
{******************************************************************************}
procedure TJvId3v2.ReadEvent(frame: TId3v2Frame; source: TStream);
var
  b:byte;
  i:Integer;
begin
   source.Read(b,1);
   dec(frame.Size);

    FEventsCount:=0;
    FEventsTiming:=b;

    while frame.size>0 do
    begin
       source.read(b,1);
       dec(frame.size,5);
       case b of
            $00 : FEvents[FEventsCount].EventType:=etPADDING;
            $01 : FEvents[FEventsCount].EventType:=etEND_OF_INITIAL_SILENCE;
            $02 : FEvents[FEventsCount].EventType:=etINTRO_START;
            $03 : FEvents[FEventsCount].EventType:=etMAINPART_START;
            $04 : FEvents[FEventsCount].EventType:=etOUTRO_START;
            $05 : FEvents[FEventsCount].EventType:=etOUTRO_END;
            $06 : FEvents[FEventsCount].EventType:=etVERSE_START;
            $07 : FEvents[FEventsCount].EventType:=etREFRAIN_START;
            $08 : FEvents[FEventsCount].EventType:=etINTERLUDE_START;
            $09 : FEvents[FEventsCount].EventType:=etTHEME_START;
            $0A : FEvents[FEventsCount].EventType:=etVARIATION_START;
            $0B : FEvents[FEventsCount].EventType:=etKEY_CHANGE;
            $0C : FEvents[FEventsCount].EventType:=eTTime_CHANGE;
            $0D : FEvents[FEventsCount].EventType:=etUNWANTED_NOISE;
            $0E : FEvents[FEventsCount].EventType:=etSUSTAINED_NOISE;
            $0F : FEvents[FEventsCount].EventType:=etSUSTAINED_NOISE_END;
            $10 : FEvents[FEventsCount].EventType:=etINTRO_END;
            $11 : FEvents[FEventsCount].EventType:=etMAINPART_END;
            $12 : FEvents[FEventsCount].EventType:=etVERSE_END;
            $13 : FEvents[FEventsCount].EventType:=etREFRAIN_END;
            $14 : FEvents[FEventsCount].EventType:=etTHEME_END;
            $FD : FEvents[FEventsCount].EventType:=etAUDIO_END;
            $FE : FEvents[FEventsCount].EventType:=etFILE_END;
       end;
       source.read(i,4);
       asm
          mov eax,i
          mov cl,al
          shl ecx,8
          mov cl,ah
          shl ecx,8
          shr eax,16
          mov cl,al
          shl ecx,8
          mov cl,ah
          mov ebx,offset i
          mov [ebx],ecx
       end;
       FEvents[FEventsCount].TimeStamp:=i;
       inc(FEventsCount);
    end;
end;
{******************************************************************************}
procedure TJvId3v2.ReadImg(frame: TId3v2Frame; source: TStream);
var
  b,c,encoding:byte;
  buf:array [0..64000] of char;
  mime,description:string;
  ptype:byte;
  picture:TMemoryStream;
  sizeleft:Integer;
  TempPath:array [0..250] of char;
  TempPat:string;
  FilePath:string;
begin
   source.read(encoding,1);
   sizeleft:=frame.Size-1;

   //Read mime type
   mime:='';
   source.read(b,1);
   dec(sizeleft);
   while b<>$00 do
   begin
      mime:=mime+char(b);
      source.read(b,1);
      dec(sizeleft);
   end;

   //Read picture type
   source.read(ptype,1);
   dec(sizeleft);

   //Read description
   if encoding=$00 then
   begin
      //ISO
      description:='';
      source.read(b,1);
      dec(sizeleft);
      while b<>$00 do
      begin
         description:=description+char(b);
         source.read(b,1);
         dec(sizeleft);
      end;
   end
   else
   begin
      //Unicode
      description:='';
      source.read(b,1);
      source.read(c,1);
      if c<>$00 then
      begin
         source.read(c,1);
         dec(sizeleft,3);
         while b<>$00 do
         begin
            description:=description+char(b);
            source.read(b,1);
            source.read(c,1);
            dec(sizeleft,2);
         end;
      end
      else dec(sizeleft,2);
   end;

   //Picture data
   picture:=TMemoryStream.Create;

   while (sizeleft>64000) do
   begin
      source.read(buf,64000);
      dec(sizeleft,64000);
      picture.Write(buf,64000);
   end;
   source.read(buf,sizeleft);
   picture.Write(buf,sizeleft);

   GetTempPath(250,TempPath);
   TempPat:=TempPath;
   if TempPat[length(TempPat)]<>'\' then TempPat:=TempPat+'\';

   FilePath:=temppat+'tmp.';
   mime:=Copy(mime,pos('/',mime)+1,length(mime));
   if UpperCase(mime)='JPEG' then filePath:=FilePath+'jpg'
   else FilePath:=FilePath+mime;
   Picture.SaveToFile(FilePath);

   case ptype of
     $00 : begin
              FImages.Pictures.Other.LoadFromFile(FilePath);
              FImages.Infos.Other:=Description;
           end;
     $01 : begin
              FImages.Pictures.FileIcon.LoadFromFile(FilePath);
              FImages.Infos.FileIcon:=Description;
           end;
     $02 : begin
              FImages.Pictures.OtherIcon.LoadFromFile(FilePath);
              FImages.Infos.OtherIcon:=Description;
           end;
     $03 : begin
              FImages.Pictures.CoverFront.LoadFromFile(FilePath);
              FImages.Infos.CoverFront:=Description;
           end;
     $04 : begin
              FImages.Pictures.CoverBack.LoadFromFile(FilePath);
              FImages.Infos.CoverBack:=Description;
           end;
     $05 : begin
              FImages.Pictures.Leaflet.LoadFromFile(FilePath);
              FImages.Infos.Leaflet:=Description;
           end;
     $06 : begin
              FImages.Pictures.Media.LoadFromFile(FilePath);
              FImages.Infos.Media:=Description;
           end;
     $07 : begin
              FImages.Pictures.LeadArtist.LoadFromFile(FilePath);
              FImages.Infos.LeadArtist:=Description;
           end;
     $08 : begin
              FImages.Pictures.Artist.LoadFromFile(FilePath);
              FImages.Infos.Artist:=Description;
           end;
     $09 : begin
              FImages.Pictures.Conductor.LoadFromFile(FilePath);
              FImages.Infos.Conductor:=Description;
           end;
     $0A : begin
              FImages.Pictures.Band.LoadFromFile(FilePath);
              FImages.Infos.Band:=Description;
           end;
     $0B : begin
              FImages.Pictures.Composer.LoadFromFile(FilePath);
              FImages.Infos.Composer:=Description;
           end;
     $0C : begin
              FImages.Pictures.Lyricist.LoadFromFile(FilePath);
              FImages.Infos.Lyricist:=Description;
           end;
     $0D : begin
              FImages.Pictures.RecordingLocation.LoadFromFile(FilePath);
              FImages.Infos.RecordingLocation:=Description;
           end;
     $0E : begin
              FImages.Pictures.DuringRecording.LoadFromFile(FilePath);
              FImages.Infos.DuringRecording:=Description;
           end;
     $0F : begin
              FImages.Pictures.DuringPerformance.LoadFromFile(FilePath);
              FImages.Infos.DuringPerformance:=Description;
           end;
     $10 : begin
              FImages.Pictures.MovieCapture.LoadFromFile(FilePath);
              FImages.Infos.MovieCapture:=Description;
           end;
     $11 : begin
              FImages.Pictures.ColouredFish.LoadFromFile(FilePath);
              FImages.Infos.ColouredFish:=Description;
           end;
     $12 : begin
              FImages.Pictures.Illustration.LoadFromFile(FilePath);
              FImages.Infos.Illustration:=Description;
           end;
     $13 : begin
              FImages.Pictures.BandLogo.LoadFromFile(FilePath);
              FImages.Infos.BandLogo:=Description;
           end;
     $14 : begin
              FImages.Pictures.PublisherLogo.LoadFromFile(FilePath);
              FImages.Infos.PublisherLogo:=Description;
           end;
   end;
   DeleteFile(FilePath);

   picture.free;
end;
{******************************************************************************}
procedure TJvId3v2.ReadIpls(frame: TId3v2Frame; source: TStream);
var
  encoding:byte;
  buf:array [0..64000] of char;
  st,st2:string;
  i:Integer;
  second:boolean;
begin
   source.read(encoding,1);
   source.read(buf,frame.size-1);
   if encoding=0 then
   begin
      //Iso
      st:='';st2:='';
      second:=false;
      for i:=0 to frame.size-2 do
      begin
         if buf[i]=#0 then
         begin
            if second then
            begin
               FInvolved.AddItem(st,st2);
               st:='';
               st2:='';
            end;
            second:=not second;
         end
         else if second then st2:=st2+buf[i]
         else st:=st+buf[i];
      end;
      if (st<>'')or(st2<>'') then
         FInvolved.AddItem(st,st2);
   end
   else
   begin
      //unicode
      st:='';st2:='';second:=false;
      i:=2;
      while i<frame.size-1 do
      begin
         if buf[i]=#0 then
         begin
            if second then
            begin
               FInvolved.AddItem(st,st2);
               st:='';st2:='';
            end;
            second:=not(second);
            inc(i,2);
         end
         else if second then st2:=st2+buf[i]
         else st:=st+buf[i];
         inc(i,2);
      end;
      if (st<>'')or(st2<>'') then
         FInvolved.AddItem(st,st2);
   end;
end;
{******************************************************************************}
procedure TJvId3v2.ReadOwner(frame: TId3v2Frame; source: TStream);
var
  encoding:byte;
  st:string;
  b:byte;
  y,d,m:Integer;
begin
   source.Read(encoding,1);
   dec(frame.Size);
   st:='';

   //Read price payed
   source.read(b,1);
   while b<>$00 do
   begin
      st:=st+char(b);
      source.read(b,1);
      dec(frame.size);
   end;
   FOwner.Price:=st;

   //Read date of purchased
   source.read(b,1);y:=b-ord('0');y:=y*10;
   source.read(b,1);y:=y+(b-ord('0'));y:=y*10;
   source.read(b,1);y:=y+(b-ord('0'));y:=y*10;
   source.read(b,1);y:=y+(b-ord('0'));

   source.read(b,1);m:=b-ord('0');m:=m*10;
   source.read(b,1);m:=m+(b-ord('0'));

   source.read(b,1);d:=b-ord('0');d:=d*10;
   source.read(b,1);d:=d+(b-ord('0'));

   FOwner.DatePurchased:=EncodeDate(y,m,d);
   dec(Frame.Size,8);
   
   //Read seller
   st:='';
   if encoding=$00 then
   begin
      while Frame.Size>0 do
      begin
         source.read(b,1);
         st:=st+char(b);
         dec(frame.Size);
      end;  
   end
   else
   begin
      //Unicode  
      if Frame.Size>2 then
      begin
         source.read(b,1);source.read(b,1);
         dec(frame.size,2);
         while Frame.Size>0 do
         begin
            source.read(b,1);
            st:=st+char(b);
            source.read(b,1);
            dec(frame.size,2);
         end;
      end;
   end;
   FOwner.Seller:=st;
end;
{******************************************************************************}
procedure TJvId3v2.ReadPop(frame: TId3v2Frame; source: TStream);
var
  st:string;
  b:byte;
  i:Integer;
begin
   source.read(b,1);
   st:='';
   while b<>$00 do
   begin
      st:=st+char(b);
      source.read(b,1);
   end;
   FPopula.UserEmail:=st;

   source.read(b,1);
   FPopula.Rating:=b;

   source.read(i,4);
   asm
      mov eax,i
      mov cl,al
      shl ecx,8
      mov cl,ah
      shl ecx,8
      shr eax,16
      mov cl,al
      shl ecx,8
      mov cl,ah
      mov ebx,offset i
      mov [ebx],ecx
   end;
   FPopula.Counter:=i;
end;
{******************************************************************************}
procedure TJvId3v2.ReadText(frame: TId3v2Frame; source: TStream);
var
  encoding:byte;
  buf:array [0..64000] of char;
  stw,stw2:Widestring;
  st,st2:string;
  i:Integer;
  second:boolean;
begin
   if frame.Id='TXXX' then
   begin
      source.read(encoding,1);
      second:=false;
      if encoding=1 then
      begin
         //Unicode
        source.Read(buf,frame.Size-1);
        stw:='';stw2:='';
        i:=2;
        while i<frame.size-2 do
        begin
           if second then stw2:=stw2+buf[i]
           else if buf[i]=#0 then
           begin
              second:=true;
              inc(i,2);
           end
           else stw:=stw+buf[i];
           inc(i,2);
        end;
        st:=stw;
        st2:=stw2;
      end
      else
      begin
         source.Read(buf,frame.Size-1);
         st:='';st2:='';
         for i:=0 to frame.size-2 do
         begin
            if second then
              st2:=st2+buf[i]
            else if buf[i]=#0 then second:=true
            else st:=st+buf[i];
         end;
      end;
      FUDText.AddItem(st,st2);
   end
   else
   begin
      source.read(encoding,1);
      if encoding=0 then
      begin
         //ISO-8859-1
         source.Read(buf,frame.Size-1);
         st:='';
         for i:=0 to frame.size-2 do
            st:=st+buf[i];
      end
      else
      begin
         //Unicode
         source.Read(buf,frame.Size-1);
         stw:='';i:=2;
         while i<frame.size-2 do
         begin
            stw:=stw+buf[i];
            inc(i,2);
         end;
         st:=stw;
      end;
   
      if frame.Id='TALB' then
          FId3Text.Album:=st
      else if frame.id='TBPM' then
          FID3Text.BPM:=StrToInt(st)
      else if frame.id='TCOM' then
      begin
         while pos('/',st)<>0 do
         begin
            FId3Text.Composer.Add(Copy(st,1,pos('/',st)-1));
            st:=Copy(st,pos('/',st)+1,length(st));
         end;
         FId3Text.Composer.Add(st);
      end
      else if frame.id='TCON' then
          FId3Text.Content:=st
      else if frame.id='TCOP' then
          FId3Text.Copyright:=st
      else if frame.id='TDAT' then
          FId3Text.Date:=st
      else if frame.id='TDLY' then
          FId3Text.PlaylistDelay:=StrToInt(st)
      else if frame.id='TENC' then
          FId3Text.EncodedBy:=st
      else if frame.id='TEXT' then
      begin
         while pos('/',st)<>0 do
         begin
            FId3Text.Lyricists.Add(Copy(st,1,pos('/',st)-1));
            st:=Copy(st,pos('/',st)+1,length(st));
         end;
         FId3Text.Lyricists.Add(st);
      end
      else if frame.id='TFLT' then
      begin
         if st='MPG' then FId3Text.FileType:=ftMPG
         else if st='MPG/1' then FId3Text.FileType:=ftMPG1
         else if st='MPG/2' then FId3Text.FileType:=ftMPG2
         else if st='MPG/3' then FId3Text.FileType:=ftMPG3
         else if st='MPG/2.5' then FId3Text.FileType:=ftMPG2_5
         else if st='MPG/AAC' then FId3Text.FileType:=ftMPG_AAC
         else if st='VQF' then FId3Text.FileType:=ftVQF
         else if st='PCM' then FId3Text.FileType:=ftPCM
         else FId3Text.FileType:=ftUNKNOW;
      end
      else if frame.id='TIME' then
          FId3Text.Time:=st
      else if frame.id='TIT1' then
          FId3Text.ContentGroup:=st
      else if frame.id='TIT2' then
          FId3Text.ContentDescription:=st
      else if frame.id='TIT3' then
          FId3Text.SubTitle:=st
      else if frame.id='TKEY' then
          FId3Text.InitialKey:=st
      else if frame.id='TLAN' then
      begin
           while length(st)>3 do
           begin
               st2:=Copy(st,1,3);
               Fid3Text.Languages.Add(Iso639ToName(st2));
               st:=Copy(st,4,length(st));
           end;
           Fid3Text.Languages.Add(Iso639ToName(st));
      end
      else if frame.id='TLEN' then
          FId3Text.Length:=st
      else if frame.id='TMED' then
      begin
         if st='DIG' then FId3Text.MediaType:=mtDIG
         else if st='DIG/A' then FId3Text.MediaType:=mtDIG_ANALOG_TRANSFER
         else if st='ANA' then FId3Text.MediaType:=mtANA
         else if st='ANA/WAC' then FId3Text.MediaType:=mtANA_WAX_CYLINDER
         else if st='ANA/8CA' then FId3Text.MediaType:=mtANA_8_TRACK_TAPE
         else if st='CD' then FId3Text.MediaType:=mtCD
         else if st='CD/A' then FId3Text.MediaType:=mtCD_ANALOG
         else if st='CD/DD' then FId3Text.MediaType:=mtCD_DDD
         else if st='CD/AD' then FId3Text.MediaType:=mtCD_ADD
         else if st='CD/AA' then FId3Text.MediaType:=mtCD_AAD
         else if st='LD' then FId3Text.MediaType:=mtLASERDISC
         else if st='LD/A' then FId3Text.MediaType:=mtLASERDISC_ANALOG_TRANSFER
         else if st='TT' then FId3Text.MediaType:=mtTURNTABLE
         else if st='TT/33' then FId3Text.MediaType:=mtTURNTABLE_33
         else if st='TT/45' then FId3Text.MediaType:=mtTURNTABLE_45
         else if st='TT/71' then FId3Text.MediaType:=mtTURNTABLE_71
         else if st='TT/76' then FId3Text.MediaType:=mtTURNTABLE_76
         else if st='TT/78' then FId3Text.MediaType:=mtTURNTABLE_78
         else if st='TT/80' then FId3Text.MediaType:=mtTURNTABLE_80
         else if st='MD' then FId3Text.MediaType:=mtMINIDISC
         else if st='MD/A' then FId3Text.MediaType:=mtMINIDISC_ANALOG_TRANSFER
         else if st='DAT' then FId3Text.MediaType:=mtDAT
         else if st='DAT/A' then FId3Text.MediaType:=mtDAT_ANALOG_TRANSFER
         else if st='DAT/1' then FId3Text.MediaType:=mtDAT_48KHZ_16B
         else if st='DAT/2' then FId3Text.MediaType:=mtDAT_32KHZ_16B
         else if st='DAT/3' then FId3Text.MediaType:=mtDAT_32KHZ_12B
         else if st='DAT/4' then FId3Text.MediaType:=mtDAT_32KHZ_12B_4CH
         else if st='DAT/5' then FId3Text.MediaType:=mtDAT_44KHZ_16B
         else if st='DAT/6' then FId3Text.MediaType:=mtDAT_44KHZ_16B_WIDE
         else if st='DCC' then FId3Text.MediaType:=mtDCC
         else if st='DCC/A' then FId3Text.MediaType:=mtDCC_ANALOG_TRANSFER
         else if st='DVD' then FId3Text.MediaType:=mtDVD
         else if st='DVD/A' then FId3Text.MediaType:=mtDVD_ANALOG_TRANSFER
         else if st='TV' then FId3Text.MediaType:=mtTV
         else if st='TV/PAL' then FId3Text.MediaType:=mtTV_PAL
         else if st='TV/NTSC' then FId3Text.MediaType:=mtTV_NTSC
         else if st='TV/SECAM' then FId3Text.MediaType:=mtTV_SECAM
         else if st='VID' then FId3Text.MediaType:=mtVID
         else if st='VID/PAL' then FId3Text.MediaType:=mtVID_PAL
         else if st='VID/NTSC' then FId3Text.MediaType:=mtVID_NTSC
         else if st='VID/SECAM' then FId3Text.MediaType:=mtVID_SECAM
         else if st='VID/VHS' then FId3Text.MediaType:=mtVID_VHS
         else if st='VID/SVHS' then FId3Text.MediaType:=mtVID_SVHS
         else if st='VID/BETA' then FId3Text.MediaType:=mtVID_BETA
         else if st='RAD' then FId3Text.MediaType:=mtRAD
         else if st='RAD/FM' then FId3Text.MediaType:=mtRAD_FM
         else if st='RAD/AM' then FId3Text.MediaType:=mtRAD_AM
         else if st='RAD/LW' then FId3Text.MediaType:=mtRAD_LW
         else if st='RAD/MW' then FId3Text.MediaType:=mtRAD_MW
         else if st='TEL' then FId3Text.MediaType:=mtTEL
         else if st='TEL/I' then FId3Text.MediaType:=mtTEL_ISDN
         else if st='MC' then FId3Text.MediaType:=mtMC
         else if st='MC/4' then FId3Text.MediaType:=mtMC_4
         else if st='MC/9' then FId3Text.MediaType:=mtMC_9
         else if st='MC/I' then FId3Text.MediaType:=mtMC_I
         else if st='MC/II' then FId3Text.MediaType:=mtMC_II
         else if st='MC/III' then FId3Text.MediaType:=mtMC_III
         else if st='MC/IV' then FId3Text.MediaType:=mtMC_IV
         else if st='REE' then FId3Text.MediaType:=mtREE
         else if st='REE/9' then FId3Text.MediaType:=mtREE_9
         else if st='REE/19' then FId3Text.MediaType:=mtREE_19
         else if st='REE/38' then FId3Text.MediaType:=mtREE_38
         else if st='REE/76' then FId3Text.MediaType:=mtREE_76
         else if st='REE/I' then FId3Text.MediaType:=mtREE_I
         else if st='REE/II' then FId3Text.MediaType:=mtREE_II
         else if st='REE/III' then FId3Text.MediaType:=mtREE_III
         else if st='REE/IV' then FId3Text.MediaType:=mtREE_IV
         else FId3Text.MediaType:=mtUNKONW;
      end
      else if frame.id='TOAL' then
          FId3Text.OriginalTitle:=st
      else if frame.id='TOFN' then
          FId3Text.OriginalFileName:=st
      else if frame.id='TOLY' then
      begin
         while pos('/',st)<>0 do
         begin
            FId3Text.OriginalLyricists.Add(Copy(st,1,pos('/',st)-1));
            st:=Copy(st,pos('/',st)+1,length(st));
         end;
         FId3Text.OriginalLyricists.Add(st);
      end
      else if frame.id='TOPE' then
      begin
         while pos('/',st)<>0 do
         begin
            FId3Text.OriginalArtist.Add(Copy(st,1,pos('/',st)-1));
            st:=Copy(st,pos('/',st)+1,length(st));
         end;
         FId3Text.OriginalArtist.Add(st);
      end
      else if frame.id='TORY' then
          FId3Text.OriginalReleaseYear:=st
      else if frame.id='TOWN' then
          FId3Text.FileOwner:=st
      else if frame.id='TPE1' then
      begin
         while pos('/',st)<>0 do
         begin
            FId3Text.Performers.Add(Copy(st,1,pos('/',st)-1));
            st:=Copy(st,pos('/',st)+1,length(st));
         end;
         FId3Text.Performers.Add(st);
      end
      else if frame.id='TPE2' then
          FId3Text.Band:=st
      else if frame.id='TPE3' then
          FId3Text.Conductor:=st
      else if frame.id='TPE4' then
          FId3Text.ModifiedBy:=st
      else if frame.id='TPOS' then
          FId3Text.PartOf:=st
      else if frame.id='TPUB' then
          FId3Text.Publisher:=st
      else if frame.id='TRCK' then
          FId3Text.TrackNumber:=st
      else if frame.id='TRDA' then
          FId3Text.RecordingDate:=st
      else if frame.id='TRSN' then
          FId3Text.InternetRadioName:=st
      else if frame.id='TRSO' then
          FId3Text.InternetRadioOwner:=st
      else if frame.id='TSIZ' then
          FId3Text.size:=StrToInt(st)
      else if frame.id='TSRC' then
          FId3Text.ISRC:=st
      else if frame.id='TSSE' then
          FId3Text.EncodingSoftware:=st
      else if frame.id='TYER' then
          FId3Text.Year:=st;
   end;
end;
{******************************************************************************}
procedure TJvId3v2.ReadWeb(frame: TId3v2Frame; source: TStream);
var
  buf:array [0..64000] of char;
  st,st2:string;
  i:Integer;
begin
   source.Read(buf,frame.Size-1);
   st:='';st2:='';
   if frame.Id='WXXX' then
   begin
      if buf[0]=#0 then
      begin
         i:=1;
         while buf[i]<>#0 do
         begin
            st:=st+buf[i];
            inc(i);
         end;
      end
      else
      begin
         //unicode description
         i:=3;
         while buf[i]<>#0 do
         begin
            st:=st+buf[i];
            inc(i,2);
         end;
      end;
      inc(i);
      while i<frame.size do
      begin
         st2:=st2+buf[i];
         inc(i);
      end;
      FUDWeb.AddItem(st,st2);
   end
   else
   begin
      for i:=0 to frame.size-2 do
          st:=st+buf[i];
      if frame.Id='WCOM' then
         FWeb.CommercialInfo:=st
      else if frame.Id='WCOP' then
         FWeb.LegalInfo:=st
      else if frame.Id='WOAF' then
         FWeb.OfficialAudio:=st
      else if frame.Id='WOAR' then
         FWeb.OfficialArtist:=st
      else if frame.Id='WOAS' then
         FWeb.OfficialAudioSource:=st
      else if frame.Id='WORS' then
         FWeb.InternetRadioStation:=st
      else if frame.Id='WPAY' then
         FWeb.Payment:=st
      else if frame.Id='WPUB' then
         FWeb.Publishers:=st;
   end;
end;
{******************************************************************************}
procedure TJvId3v2.ResetProp;
begin
   FVersion:=0.0;
   FUnsynchro:=false;
   FExperimental:=false;
   FExtended:=false;

   FId3Text.ResetFields;
   FUDText.ResetFields;
   FWeb.ResetFields;
   FUDWeb.ResetFields;
   FInvolved.ResetFields;
   FImages.ResetFields;
   FOwner.ResetFields;
   FPopula.ResetFields;

   FCounter:=0;
   FillChar(MusicCDIdentifier,804,0);
   MusicCDIdentifierLength:=0;
end;
{******************************************************************************}
procedure TJvId3v2.SetFileName(const Value: TFileName);
begin
   FTagSize:=0;  
   FFileName := Value;
   LoadFromFile(Value);
end;
{******************************************************************************}
procedure TJvId3v2.SkipFrame(frame: TId3v2Frame; var source: TStream);
begin
   source.Position:=source.position+frame.Size;
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvId3Text
///////////////////////////////////////////////////////////

{******************************************************************************}
constructor TJvId3Text.Create;
begin
   inherited;
   FComposer:=TstringList.Create;
   FLyricist:=TstringList.Create;
   FLanguages:=TstringList.Create;
   FOLyricists:=TstringList.Create;
   FOArtist:=TstringList.Create;
   FPerformers:=TstringList.Create;
end;
{******************************************************************************}
destructor TJvId3Text.Destroy;
begin
   FComposer.free;
   FLyricist.free;
   FLanguages.free;
   FOLyricists.free;
   FOArtist.free;
   FPerformers.free;
   inherited;
end;
{******************************************************************************}
procedure TJvId3Text.ResetFields;
begin
   FBPM:=0;
   FAlbum:='';
   FComposer.clear;
   FDelay:=0;
   FCopyright:='';
   FEncodedBy:='';
   FDate:='';
   FLyricist.clear;
   FFileType:=ftUNKNOW;
   FTIme:='';
   FInitialKey:='';
   FContent:='';
   FSubTitle:='';
   FContentD:='';
   FLanguages.clear;
   FLength:='';
   FMediaType:=mtUNKONW;
   FOriginal:='';
   FFileName:='';
   FOLyricists.clear;
   FOArtist.clear;
   FOwner:='';
   FOYear:='';
   FPerformers.clear;
   FConductor:='';
   FModified:='';
   FBand:='';
   FPart:='';
   FPublisher:='';
   FTrackNumber:='';
   FRecording:='';
   FInternet:='';
   FIOwner:='';
   FSize:=0;
   FISRC:='';
   FEncoding:='';
   FYear:='';
   FContent:='';
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvId3Web
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvId3Web.ResetFields;
begin
   FAudio:='';
   FStation:='';
   FPublishers:='';
   FASource:='';
   FPayment:='';
   FLegal:='';
   FCommercial:='';
   FArtist:='';
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvID3UDText
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvID3UDText.AddItem(desc, Value: string);
begin
   Fstrings.add(Value);
   FDescriptions.add(desc);
   SetItem(0);
   FCount:=Fstrings.Count;
end;
{******************************************************************************}
constructor TJvID3UDText.Create;
begin
   Fstrings:=TstringList.Create;
   FDescriptions:=TstringList.Create;
end;
{******************************************************************************}
destructor TJvID3UDText.Destroy;
begin
   Fstrings.free;
   FDescriptions.free;
   inherited;
end;
{******************************************************************************}
procedure TJvID3UDText.ResetFields;
begin
   Fstrings.clear;
   FDescriptions.clear;
end;
{******************************************************************************}
procedure TJvID3UDText.SetItem(const Value: integer);
begin
   FItems := Value;
   if Value<Fstrings.count then
   begin
      FDescription:=FDescriptions[Value];
      FValue:=Fstrings[Value];
   end
   else
   begin
      FDescription:='';
      FValue:='';
   end;
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvID3UDUrl
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvID3UDUrl.AddItem(desc, Value: string);
begin
   Fstrings.add(Value);
   FDescriptions.add(desc);
   SetItem(0);
   FCount:=Fstrings.Count;
end;
{******************************************************************************}
constructor TJvID3UDUrl.Create;
begin
   Fstrings:=TstringList.Create;
   FDescriptions:=TstringList.Create;
end;
{******************************************************************************}
destructor TJvID3UDUrl.Destroy;
begin
   Fstrings.free;
   FDescriptions.free;
   inherited;
end;
{******************************************************************************}
procedure TJvID3UDUrl.ResetFields;
begin
   Fstrings.clear;
   FDescriptions.clear;
end;
{******************************************************************************}
procedure TJvID3UDUrl.SetItem(const Value: integer);
begin
   FItems := Value;
   if Value<Fstrings.count then
   begin
      FDescription:=FDescriptions[Value];
      FValue:=Fstrings[Value];
   end
   else
   begin
      FDescription:='';
      FValue:='';
   end;
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvIdPictures
///////////////////////////////////////////////////////////

{******************************************************************************}
constructor TJvIdPictures.Create;
begin
   FMedia:=TPicture.Create;
   FLyricist:=TPicture.Create;
   FIcon:=TPicture.Create;
   FComposer:=TPicture.Create;
   FRLocation:=TPicture.Create;
   FOther:=TPicture.Create;
   FFish:=TPicture.Create;
   FCoverFront:=TPicture.Create;
   FBandLogo:=TPicture.Create;
   FConductor:=TPicture.Create;
   FPublisherLogo:=TPicture.Create;
   FDRecording:=TPicture.Create;
   FArtist:=TPicture.Create;
   FLeaflet:=TPicture.Create;
   FOther:=TPicture.Create;
   FDPerformance:=TPicture.Create;
   FIllustration:=TPicture.Create;
   FBand:=TPicture.Create;
   FMove:=TPicture.Create;
   FCoverBack:=TPicture.Create;
   FOtherIcon:=TPicture.Create;
   FLeadArtist:=TPicture.Create;
end;
{******************************************************************************}
destructor TJvIdPictures.Destroy;
begin
   FMedia.free;
   FLyricist.free;
   FIcon.free;
   FComposer.free;
   FRLocation.free;
   FOther.free;
   FFish.free;
   FCoverFront.free;
   FBandLogo.free;
   FConductor.free;
   FPublisherLogo.free;
   FDRecording.free;
   FArtist.free;
   FLeaflet.free;
   FDPerformance.free;
   FIllustration.free;
   FBand.free;
   FMove.free;
   FCoverBack.free;
   FOtherIcon.free;
   FLeadArtist.free;
   inherited;
end;
{******************************************************************************}
procedure TJvIdPictures.SetArtist(const Value: TPicture);
begin
   FArtist.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetBand(const Value: TPicture);
begin
   FBand.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetBandLogo(const Value: TPicture);
begin
   FBandLogo.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetComposer(const Value: TPicture);
begin
   FComposer.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetConductor(const Value: TPicture);
begin
   FConductor.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetCoverBack(const Value: TPicture);
begin
   FCoverBack.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetCoverFront(const Value: TPicture);
begin
   FCoverFront.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetDRecording(const Value: TPicture);
begin
   FDRecording.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetFish(const Value: TPicture);
begin
   FFish.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetICon(const Value: TPicture);
begin
   FIcon.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetIllustration(const Value: TPicture);
begin
   FIllustration.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetLeadArtist(const Value: TPicture);
begin
   FLeadArtist.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetLeaflet(const Value: TPicture);
begin
   FLeaflet.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetLocation(const Value: TPicture);
begin
   FRLocation.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetLyricist(const Value: TPicture);
begin
   FLyricist.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetMedia(const Value: TPicture);
begin
   FMedia.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetMovie(const Value: TPicture);
begin
   FMove.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetOther(const Value: TPicture);
begin
   FOther.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetOtherIcon(const Value: TPicture);
begin
   FOtherIcon.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetPerformance(const Value: TPicture);
begin
   FDPerformance.Assign(Value);
end;
{******************************************************************************}
procedure TJvIdPictures.SetPublisherLogo(const Value: TPicture);
begin
   FPublisherLogo.Assign(Value);
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvIdImages
///////////////////////////////////////////////////////////

{******************************************************************************}
constructor TJvIdImages.Create;
begin
   FPictures:=TJvIdPictures.Create;
   FInfos:=TJvIdPicturesDesc.Create;
end;
{******************************************************************************}
destructor TJvIdImages.Destroy;
begin
   FPictures.free;
   FInfos.free;
   inherited;
end;
{******************************************************************************}
procedure TJvIdImages.ResetFields;
begin
   FPictures.Other.Assign(nil);
   FPictures.FileIcon.Assign(nil);
   FPictures.OtherIcon.Assign(nil);
   FPictures.CoverFront.Assign(nil);
   FPictures.CoverBack.Assign(nil);
   FPictures.Leaflet.Assign(nil);
   FPictures.Media.Assign(nil);
   FPictures.Artist.Assign(nil);
   FPictures.Conductor.Assign(nil);
   FPictures.Band.Assign(nil);
   FPictures.Composer.Assign(nil);
   FPictures.Lyricist.Assign(nil);
   FPictures.RecordingLocation.Assign(nil);
   FPictures.DuringRecording.Assign(nil);
   FPictures.DuringPerformance.Assign(nil);
   FPictures.MovieCapture.Assign(nil);
   FPictures.ColouredFish.Assign(nil);
   FPictures.Illustration.Assign(nil);
   FPictures.BandLogo.Assign(nil);
   FPictures.PublisherLogo.Assign(nil);
   FPictures.LeadArtist.Assign(nil);
   FInfos.Other:='';
   FInfos.FileIcon:='';
   FInfos.OtherIcon:='';
   FInfos.CoverFront:='';
   FInfos.CoverBack:='';
   FInfos.Leaflet:='';
   FInfos.Media:='';
   FInfos.Artist:='';
   FInfos.Conductor:='';
   FInfos.Band:='';
   FInfos.Composer:='';
   FInfos.Lyricist:='';
   FInfos.RecordingLocation:='';
   FInfos.DuringRecording:='';
   FInfos.DuringPerformance:='';
   FInfos.MovieCapture:='';
   FInfos.ColouredFish:='';
   FInfos.Illustration:='';
   FInfos.BandLogo:='';
   FInfos.PublisherLogo:='';
   FInfos.LeadArtist:='';
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvIdIpl
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvIdIpl.AddItem(Job, Person: string);
begin
   FJobs.add(Job);
   FPersons.add(person);
   SetItem(0);
   inc(FCount);
end;
{******************************************************************************}
constructor TJvIdIpl.Create;
begin
   FJobs:=TstringList.Create;
   FPersons:=TstringList.Create;
end;
{******************************************************************************}
destructor TJvIdIpl.Destroy;
begin
   FJobs.free;
   FPersons.free;
   inherited;
end;
{******************************************************************************}
procedure TJvIdIpl.ResetFields;
begin
   FJobs.clear;
   FPersons.clear;
end;
{******************************************************************************}
procedure TJvIdIpl.SetItem(const Value: integer);
begin
   FItems := Value;
   if Value<FJobs.Count then
   begin
      FJob:=FJobs[Value];
      FPerson:=FPersons[Value];
   end
   else
   begin
      FJob:='';
      FPerson:='';
   end;
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvId3Owner
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvId3Owner.ResetFields;
begin
   FSeller:='';
   FPrice:='';
   FDate:=EncodeDate(1900,1,1);
end;
{******************************************************************************}

///////////////////////////////////////////////////////////
// TJvId3Popularimeter
///////////////////////////////////////////////////////////

{******************************************************************************}
procedure TJvId3Popularimeter.ResetFields;
begin
  FRating:=0;
  FCounter:=0;
  FEmail:='';
end;
{******************************************************************************}

end.
