{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvImageCombobox.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvImageCombobox;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, JvCombobox, ImgList;

type
  TJvImageCombobox = class(TJvCombobox)
  private
    FImage: TImageList;
    procedure SetImage(const Value: TImageList);
    procedure CNMeasureItem(var Message: TWMMeasureItem); message CN_MEASUREITEM;
  protected
  public
    constructor Create(AOwner: TComponent);override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
  published
    property Images:TImageList read FImage write SetImage;
  end;

implementation

{***************************************************}
procedure TJvImageCombobox.CNMeasureItem(var Message: TWMMeasureItem);
var
   b:TBitmap;
begin
   with Message.MeasureItemStruct^ do
   begin
      if FImage<>nil then
      begin
         b:=TBitmap.Create;
         FImage.GetBitmap(itemid,b);
         itemHeight:=b.height;
         b.free;
      end
      else
         itemHeight:=self.itemHeight;
   end;
end;
{***************************************************}
constructor TJvImageCombobox.Create(AOwner: TComponent);
begin
   inherited;
   style := csOwnerDrawVariable;
   Controlstyle:= Controlstyle + [csAcceptsControls];
end;
{***************************************************}
procedure TJvImageCombobox.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
var
 FBmp:TBitmap;
 d:TDrawingstyle;
begin
   if FImage<>nil then
   begin
      d:=FImage.Drawingstyle;
      if (odSelected in state) or (odGrayed in state)or ( odDisabled in state) or (odChecked in state)
         or (odFocused in state) then
           FImage.Drawingstyle:=dsFocus;
      FBmp:=TBitMap.Create;
      FImage.GetBitmap(index,FBmp);
      ItemHeight:=FBmp.Height;
      with Canvas Do
      begin
         FillRect(Rect);
         Draw(Rect.Left-1,Rect.Top+0, FBmp);
         TextOut(Rect.Left+2+FBmp.Width,Rect.Top+2,Items.strings[Index]);
      end;
      FBmp.Free;
      FImage.Drawingstyle:=d;
   end;
end;
{***************************************************}
procedure TJvImageCombobox.SetImage(const Value: TImageList);
begin
   FImage:=Value;
   if FImage<>nil then
      ItemHeight:=FImage.Height;
   invalidate;
end;
{***************************************************}
end.
