{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvItemsSearchs.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvItemsSearchs;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms;

type
  TJvItemsSearchs = class(TObject)
  public
    function SearchExactString(Items: TStrings;Value: string; CaseSensitive: Boolean = true):Integer;
    function SearchPrefix(Items: TStrings;Value: string; CaseSensitive: Boolean = true):Integer;
    function SearchSubString(Items: TStrings;Value: string; CaseSensitive: Boolean = true):Integer;
    function DeleteExactString(Items: TStrings;Value: string; All: Boolean;
      CaseSensitive: Boolean = true):Integer;
  end;

implementation

{***********************************************}
function TJvItemsSearchs.DeleteExactString(Items: TStrings; Value: string;
  All, CaseSensitive: Boolean): Integer;
var
 i: Integer;
begin
  result := 0;
  i := SearchExactString(Items,Value,CaseSensitive);
  while i<>-1 do
  begin
    inc(result);
    items.Delete(i);
    if All then
      i := SearchExactString(Items,Value,CaseSensitive)
    else
      Exit;
  end;
end;
{***********************************************}
function TJvItemsSearchs.SearchExactString(Items: TStrings; Value: string;
  CaseSensitive: Boolean): Integer;
var
 i: Integer;
begin
  result := -1;
  if CaseSensitive then
    result := Items.IndexOf(Value)
  else
  begin
    Value := UpperCase(Value);
    for i:=0 to Items.Count-1 do
      if Pos(Value,UpperCase(Items[i]))=1 then
      begin
        result := i;
        Exit;
      end;
  end;
end;
{***********************************************}
function TJvItemsSearchs.SearchPrefix(Items: TStrings; Value: string;
  CaseSensitive: Boolean): Integer;
var
 i: Integer;
begin
  result := -1;
  if CaseSensitive then
  begin
    for i:=0 to Items.Count-1 do
      if Pos(Value,Items[i])=1 then
      begin
        result := i;
        Exit;
      end;
  end
  else
  begin
    Value := UpperCase(Value);
    for i:=0 to Items.Count-1 do
      if Pos(Value,UpperCase(Items[i]))=1 then
      begin
        result := i;
        Exit;
      end;
  end;
end;
{***********************************************}
function TJvItemsSearchs.SearchSubString(Items: TStrings; Value: string;
  CaseSensitive: Boolean): Integer;
var
 i: Integer;
begin
  result := 0;
  if CaseSensitive then
  begin
    for i:=0 to Items.Count-1 do
      if Pos(Value,Items[i])<>0 then
      begin
        result := i;
        Exit;
      end;
  end
  else
  begin
    Value := UpperCase(Value);
    for i:=0 to Items.Count-1 do
      if pos(Value,UpperCase(Items[i]))<>0 then
      begin
        result := i;
        Exit;
      end;
  end;
end;
{***********************************************}
end.
