{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvPackReg.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvPackReg;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, ExtCtrls,

  //Additional
  JvImage, JvBitBtn, JvSpeedButton, JvMaskEdit, JvStaticText, JvCheckListBox,
  JvBevel, JvScrollBox, JvStringGrid, JvDrawGrid, JvShape, JvControlBar,
  JvSplitter,

  //Standard 
  JvListbox2, JvEdit, JvCombobox, JvCheckBox, JvRadioButton, JvButton,
  JvLabel, JvScrollBar, JvGroupBox2, JvRadioGroup, JvPanel, JvMemo,

  //Edits
  JvCustomBox, JvFileNameBox, JvDirectoryBox, JvImageBox, JvButtonBox,
  JvIpBox, JvFloatEdit, JvCalculatorBox, JvFontBox,

  //Install
  JvGradient, JvInstaller, JvWelcome, JvAgreement, JvConfirmCancel,
  JvReadme, JvSelectDir, JvSelectGroup, JvInstallType, JvCompoInstall,
  JvInstallProgress, JvUsernameSerial, JvFinishInstall, JvGeneralForm,
  JvInstallConfirm, JvUnInstaller,

  //Controls
  JvPlaylist, JvButtonShaped, JvFavoritesButton, JvClock, JvStartMenuBtn,
  JvScrollText, JvFontCombobox, JvRecentMenuBtn, JvControlPanel,
  JvRegistryViewer, JvGradientCaption, JvImageListBox, JvImageCombobox,
  JvZoom, JvWaitingGradient, JvSpecialProgress, JvWaitingProgress,
  JvGammaPanel, JvSlider, JvOutlookPanel,

  //Mp3
  JvBreatheSkin, JvId3v2, JvVisualId3v2, JvWinampApi, JvId3v1, JvVisualId3v1,

  //Multimedia
  JvCreatedWith, JvSoundControl, JvCdUtils, JvScreenCapture,
  JvWallPaper, JvDeviceChanged, JvImageTransform, JvImageRotate,
  JvWavePlayer, JvImageSplit, JvStarfield, JvJoystick, JvScreenResolution,
  JvScreenCanvas, JvSpecialImage,

  //Labels
  JvHotLink, JvBlinkingLabel, JvScrollingLabel, JvMailTo, JvReversedLabel,
  JvRealLabel, JvSpecialLabel, JvWinampLabel, JvAngleLabel, JvBouncingLabel,
  JvAppearingLabel,

  //Forms
  JvFormWallpaper, JvAnimTitle, JvPerforated, JvFlashForm,
  JvTransparentForm, JvTrayIcon, JvTransForm, JvFormAnimatedIcon,
  JvAppAnimatedIcon, JvFormPlace, JvNotitle, JvFormAnimation,
  JvAutoSizeCompo, JvFlashApplication, JvFormButton, JvMagnet,

  //Convert
  JvStringListToHtml, JvRgbToHtml, JvStrToHtml, JvRichEditToHtml,
  JvFormToHtml,

  //Internet
  JvHttpGrabber, JvFtpGrabber, JvHtmlParser, JvSurfTo, JvImageMailto,
  JvImageSurfTo, JvMultiHttpGrabber,

  //Utils
  JvChrono, JvComplex, JvCplLauncher, JvCreateShortcut,
  JvExecute, JvExitWindows, JvDirectories, JvFileUtils,
  JvDrivePresent, JvInstances, JvMemoryInfos, JvTrayBar,
  JvSerialMaker, JvThread, JvSafeMode, JvRegistry, JvSendKey,
  JvApplication, JvFileInformations, JvRecentDocs, JvAlarms,
  JvKeyboardStates, JvAssociateExtension, JvDragDrop, JvSearchFile,

  //Utils 2
  JvMru, JvRas32, JvSystemPopup, JvDirectorySpy, JvMousePositionner,
  JvWinHelp, JvEasterEgg, JvWindowsTitle, JvPrint, JvThreadTimer,
  JvTimeLimit, JvScreenSaver, JvClipboardViewer, JvSystemColors,
  JvPatchFile, JvRunOnStartup, JvComputerInfo, JvCommStatus, JvLogFile,
  JvCabFile, JvRle, JvDataEmbedded,

  //Utils 3
  JvRegion, JvCaesarCipher, JvVigenereCipher, JvXorCipher, JvGenetic,

  //Dialogs
  JvCommonDialogD, JvBaseDlg, JvFormatDrive, JvFindFiles, JvBrowseFolder,
  JvSelectDirectory, JvInputBox, JvOpenAs, JvAddPrinter, JvConnectNetwork,
  JvDisconnectNetwork, JvPasswordForm, JvMessageBox, JvMessageBeep,
  JvFatalAppExit, JvExchListboxes, JvLoginDlg, JvSerialDlg, JvNagScreen,
  JvTipsOfDay, JvImageDlg, JvCalculator, JvProgressDlg, JvDiskPrompt,
  JvCopyError, JvDeleteError, JvRenameError, JvShellAbout,

  //Dialogs 2
  JvShutdownDlg, JvRestartDlg, JvChooseIconDlg, JvRunDlg,
  JvFindComputerDlg, JvObjectPropertiesDlg, JvOutOfMemoryDlg,
  JvOutOfSpaceDlg, JvOpenDialog2, JvSaveDialog2,

  //Win32
  JvStatusBar2, JvTabControl, JvPageControl2, JvRichEdit, JvTrackBar2,
  JvProgressBar, JvUpDown2, JvHotKey, JvAnimate, JvDateTimePicker,
  JvMonthCalendar, JvTreeView2, JvListView, JvHeaderControl, JvToolBar,
  JvCoolBar, JvPageScroller,

  //Image types
  JvPcx, JvAni,


  //Editors
  JvDataEmbeddedEditor, JvFormWallpaperEditor, JvPatcherEditor,
  JvHtmlParserEditor, JvAlarmsEditor, JvRegisterEditor, JvBaseDlgEditor,
  JvBaseDlgEditorP, JvCommonDialogDEditor,

  Dialogs, ExptIntf, ToolIntf, ExtDlgs, StdCtrls, Buttons, DsgnIntf,
  JvTypes;

procedure Register;

implementation

{$r JvPackReg.dcr}

{******************************************************************************}
procedure Register;
begin
  //Total: 232 components

  //Registering Standard components - 12
  RegisterComponents('Jv Standard', [TJvLabel, TJvEdit, TJvMemo, TJvButton, TJvCheckBox,
    TJvRadioButton, TJvListbox2, TJvCombobox, TJvScrollBar, TJvGroupBox2, TJvRadioGroup,
    TJvPanel]);

  //Registering Additional components - 13
  RegisterComponents('Jv Additional', [TJvBitBtn, TJvSpeedButton, TJvMaskEdit,
    TJvStringGrid, TJvDrawGrid, TJvImage, TJvShape, TJvBevel, TJvScrollBox,
    TJvCheckListBox, TJvSplitter, TJvStaticText, TJvControlBar]);

  //Registering Labels components - 11
  RegisterComponents('Jv Labels',[TJvHotLink, TJvBlinkingLabel, TJvScrollingLabel,
    TJvMailTo, TJvReversedLabel, TJvRealLabel, TJvSpecialLabel, TJvWinampLabel,
    TJvAngleLabel, TJvBouncingLabel, TJvAppearingLabel]);

  //Registering Multimedia components - 15
  RegisterComponents('Jv Multimedia',[TJvSoundControl, TJvCdUtils,
    TJvScreenCapture, TJvWallpaper, TJvDeviceChanged, TJvImageTransform,
    TJvImageRotate, TJvWavePlayer, TJvCreatedWith, TJvImageSplit,
    TJvStarfield, TJvJoystick, TJvScreenResolution, TJvScreenCanvas,
    TJvSpecialImage]);

  //Registering Forms enhancement components - 14
  RegisterComponents('Jv Forms',[TJvFormWallpaper, TJvAnimtitle, TJvPerforated,
    TJvFlashForm, TJvTransparentForm, TJvTrayIcon, TJvTransForm, TJvFormAnimatedIcon,
    TJvAppAnimatedIcon, TJvFormPlace, TJvNoTitle, TJvFormAnimation, TJvAutoSizeCompo,
    TJvFlashApplication, TJvFormButton, TJvFormMagnet]);

  //Registering Utils components - 23
  RegisterComponents('Jv Utils',[TJvChrono, TJvComplex, TJvCplLauncher,
    TJvCreateShortcut, TJvExecute, TJvExitWindows, TJvAlarms,
    TJvDirectories, TJvFilesUtils, TJvDrivePresent, TJvInstances,
    TJvTraybar, TJvSerialMaker, TJvThread, TJvSafeMode, TJvSendKey,
    TJvApplication, TJvRecentDocs, TJvFileInformations, TJvKeyboardStates,
    TJvAssociateExtension, TJvDragDrop, TJvSearchFile]);

  //Registering Utils2 components - 22
  RegisterComponents('Jv Utils 2',[TJvTimeLimit, TJvScreenSaver, TJvClipboardViewer,
    TJvSystemColors, TJvPatchFile, TJvRunOnStartup, TJvRas32,  TJvComputerInfo,
    TJvCommStatus, TJvThreadTimer, TJvSystemPopup, TJvDirectorySpy,
    TJvMousePositionner, TJvMruList, TJvWinHelp, TJvEasterEgg, TJvWindowsTitle,
    TJvPrint, TJvLogFile, TJvCabFile, TJvRle, TJvDataEmbedded]);

  //Registering Utils2 components - 5
  RegisterComponents('Jv Utils 3',[TJvRegion, TJvCaesarCipher, TJvVigenereCipher,
    TJvXorCipher, TJvGenetic]);

  //Registering Dialogs components - 26
  RegisterComponents('Jv Dialogs',[TJvFormatDrive, TJvFindFiles, TJvBrowseFolder,
    TJvShellAbout, TJvSelectDirectory, TJvInputBox, TJvOpenAs, TJvAddPrinter,
    TJvConnectNetwork, TJvDisconnectNetwork, TJvPasswordForm, TJvMessageBox,
    TJvMessageBeep, TJvFatalAppExit, TJvExchListboxes, TJvLoginDlg,
    TJvSerialDlg, TJvNagScreen, TJvTipsOfDay, TJvImageDlg, TJvCalculator,
    TJvProgressDlg, TJvDiskPrompt, TJvCopyError, TJvDeleteError, TJvRenameError]);

  //Registering Dialogs components - 10
  RegisterComponents('Jv Dialogs 2',[TJvShutdownDlg, TJvRestartDlg, TJvChooseIconDlg,
    TJvRunDlg, TJvFindComputerDlg, TJvObjectPropertiesDlg, TJvOutOfMemoryDlg,
    TJvOutOfSpaceDlg, TJvOpenDialog2, TJvSaveDialog2]);

  //Registering Controls components - 19
  RegisterComponents('Jv Controls',[TJvPlaylist, TJvButtonShaped, TJvFavoritesButton,
    TJvStartMenuBtn, TJvClock, TJvGammaPanel, TJvScrollText, TJvFontCombobox,
    TJvRecentMenuBtn, TJvControlPanel, TJvRegistryViewer, TJvSlider, TJvGradientCaption,
    TJvImageListBox, TJvImageCombobox, TJvZoom, TJvWaitingGradient, TJvSpecialProgress,
    TJvWaitingProgress, TJvOutlookPanel]);

  //Register Win32 components - 17
  RegisterComponents('Jv Win32',[TJvStatusBar2, TJvTabControl, TJvPageControl2,
    TJvRichEdit, TJvTrackBar2, TJvProgressBar, TJvUpDown2, TJvHotKey,
    TJvAnimate, TJvDateTimePicker, TJvMonthCalendar, TJvTreeView2, TJvListView,
    TJvHeaderControl, TJvToolBar, TJvCoolBar, TJvPageScroller]);

  //Register Net components - 7
  RegisterComponents('Jv Net',[TJvHtmlParser, TJvSurfTo, TJvImageSurfTo, TJvImageMailTo,
    TJvHttpGrabber, TJvMultiHttpGrabber, TJvFtpGrabber]);

  //Register Edits Components - 8
  RegisterComponents('Jv Edits',[TJvFileNameBox, TJvDirectoryBox, TJvImageBox,
   TJvButtonBox, TJvIpBox, TJvFloatEdit, TJvCalculatorBox, TJvFontBox]);

  //Register Install Components - 15
  RegisterComponents('Jv Install',[TJvGradient, TJvInstaller, TJvWelcome, TJvAgreement,
    TJvConfirmCancel, TJvReadme, TJvSelectDir, TJvSelectGroup, TJvInstallType,TJvCompoInstall,
    TJvInstallConfirm, TJvInstallProgress, TJvUsernameSerial, TJvFinishInstall,
    TJvGeneralForm, TJvUnInstaller]);

  //Register Convert Components - 5
  RegisterComponents('Jv Convert',[TJvStringListToHtml, TJvRichEditToHtml,
    TJvRgbToHtml, TJvStrToHtml, TJvFormToHtml]);

  //Register MP3 Components - 6
  RegisterComponents('Jv MP3',[TJvId3v1, TJvVisualId3v1, TJvId3v2, TJvBreatheSkin,
    TJvWinampApi, TJvVisualId3v2]);

  //Register property editors - 5
  RegisterPropertyEditor(TypeInfo(TStream),TJvDataEmbedded,'Data',TJvDataEmbeddedEditor);
  RegisterPropertyEditor(TypeInfo(TPicture),TJvFormWallpaper,'Image',TJvFormWallpaperEditor);
  RegisterPropertyEditor(TypeInfo(TstringList),TJvPatchFile,'Differences',TJvPatcherEditor);
  RegisterPropertyEditor(TypeInfo(TstringList),TJvAlarms,'Alarms',TJvAlarmsEditor);
  RegisterPropertyEditor(TypeInfo(TParserInfos),TJvHtmlParser,'Parser',TJvHtmlParserEditor);

  //Register component editors - 3
  RegisterComponentEditor(TJvCommonDialog,  TJvBaseDlgEditor);
  RegisterComponentEditor(TJvCommonDialogP, TJvBaseDlgEditorP);
  RegisterComponentEditor(TJvCommonDialogD, TJvCommonDialogDEditor);

  {$WARNINGS OFF}
  RegisterLibraryExpert(TJvRegisterExpert.Create);
  {$WARNINGS ON}
end;
{******************************************************************************}
end.

