{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvPrint.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvPrint;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Printers, JvTypes;

type
  TJvPrint = class(TComponent)
  private
    FOnBegin: TNotifyEvent;
    FOnEnded: TNotifyEvent;
    FOnProgress: TOnPrnProgress;
    FOnNextP: TOnNextP;
  protected
  public
  published
    procedure Print(Value:TstringList);
    procedure PrintImage(Value:TBitmap;style:TBitmapstyle);
    procedure Abort;
    property OnBeginPrint:TNotifyEvent read FOnbegin write FOnBegin;
    property OnFinishedPrint:TNotifyEvent read FOnEnded write FOnEnded;
    property OnProgress:TOnPrnProgress read FOnProgress write FOnProgress;
    property OnNextPage:TOnNextP read FOnNextP write FOnNextP;
  end;

implementation

{**************************************************}
procedure TJvPrint.Abort;
begin
   Printer.Abort;
end;
{**************************************************}
procedure TJvPrint.Print(Value: TstringList);
var
  I,Line,pagenum:Integer;
begin
   //let's print
   if Assigned(FOnBegin) then FOnBegin(self);
   line:=0 ;
   Printer.BeginDoc;
   pagenum:=1;
   for i:=0 to Value.Count-1 do
   begin
      if Assigned(FOnProgress) then
         FOnProgress(self,i+1,Value.count);

      Line:=Line+Printer.Canvas.TextHeight(Value[i]);
      if Line+Printer.Canvas.TextHeight(Value[i])>Printer.PageHeight then
      begin
         Line:=Printer.Canvas.TextHeight(Value[i]);
         Printer.NewPage;
         inc(PageNum);
         if Assigned(FonNextP) then
            FonNextP(self,PageNum);
      end;

      Printer.Canvas.TextOut(0,line,Value[I]);
   end;
   Printer.EndDoc;
   if Assigned(FOnEnded) then FOnEnded(self);
end;
{**************************************************}
procedure TJvPrint.PrintImage(Value:TBitmap;style:TBitmapstyle);
begin
   //let's print too :)
   if Assigned(FOnBegin) then FOnBegin(self);
   case style of
        bsNormal : begin
                      with Printer do
                      begin
                         BeginDoc;
                         Canvas.draw(0,0,Value);
                         EndDoc;
                      end;
                   end;
        bsCentered : begin
                        with Printer do
                        begin
                           BeginDoc;
                           Canvas.Draw((PageWidth-Value.Width)div 2,(PageHeight-Value.Height)div 2,Value);
                           EndDoc;
                        end;
                     end;
        bsStretched : begin
                         with Printer do
                         begin
                            BeginDoc;
                            Canvas.StretchDraw(Rect(0,0,PageWidth,PageHeight),Value);
                            EndDoc;
                         end;
                      end;
   end;
   if Assigned(FOnEnded) then FOnEnded(self);
end;
{**************************************************}
end.
