{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRegistry.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvRegistry;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Registry,
  JvTypes{$IFDEF D6},Variants{$ENDIF};

type
  TJvRegistry = class(TRegistry)
  private
  protected
  public
  published
    procedure Write(field:string;Value:variant);
    function Read(field:string):variant;
  end;

implementation

{********************************************************}
procedure TJvRegistry.Write(field:string;Value:variant);
begin
   case varType(Value) of
        varCurrency : writeCurrency(field,Value);
        varboolean  : WriteBool(field,Value);
        vardate     : writedatetime(field,Value);
        varsingle,vardouble:writefloat(field,Value);
        varinteger:WriteInteger(field,Value);
        varstring:WriteString(field,Value);
   end;
end;
{********************************************************}
function TJvRegistry.Read(field:string):variant;
begin
   if Valueexists(field) then
   case varType(result) of
        varCurrency : result:=readCurrency(field);
        varboolean  : result:=ReadBool(field);
        vardate     : result:=readdatetime(field);
        varsingle,vardouble:result:=readfloat(field);
        varinteger:result:=ReadInteger(field);
        varstring:result:=ReadString(field);
   end;
end;
{********************************************************}
end.
