{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRgbToHtml.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvRgbToHtml;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls;

type
  TJvRgbToHtml = class(TComponent)
  private
    FHtml: string;
    FColor: TColor;
    procedure SeTColor(const Value: TColor);
    procedure SetHtml(const Value: string);
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property RgbColor:TColor read FColor write SeTColor default clBlack;
    property HtmlColor:string read FHtml write SetHtml;
  end;

  function RgbToHtml(Value: TColor):string;

implementation

{**************************************************}
function RgbToHtml(Value: TColor):string;
begin
  with TJvRgbToHtml.Create(nil) do
  begin
    RgbColor:=Value;
    result:=HtmlColor;
    Free;
  end;
end;
{**************************************************}
constructor TJvRgbToHtml.Create(AOwner: TComponent);
begin
  inherited;
  FColor := clBlack;
  FHtml := '000000';
end;
{**************************************************}
procedure TJvRgbToHtml.SeTColor(const Value: TColor);
var
 Clr:TColor;
begin
  FColor := Value;  Clr := Value;
  if (Clr<0) then Clr:=GetSysColor(Clr and not( $80000000));
  FHtml:=IntToHex(GetRValue(Clr),2)+IntToHex(GetGValue(Clr),2)+IntToHex(GetBValue(Clr),2);
end;
{**************************************************}
procedure TJvRgbToHtml.SetHtml(const Value: string);
var
 c:TColor;
 r,g,b:byte;
begin
  try
   if length(Value)=6 then
   begin
     r:=StrToInt('$'+Copy(Value,1,2));
     g:=StrToInt('$'+Copy(Value,3,2));
     b:=StrToInt('$'+Copy(Value,5,2));
     c:=Rgb(r,g,b);
     Fcolor:=c;

     FHtml:=Value;
   end;
  except
  end;
end;
{**************************************************}
end.

