{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRunDlg.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvRunDlg;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvBaseDlg, JvHDialogs2, JvTypes;

type
  TJvRunDlg = class(TJvCommonDialogP)
  private
    FDesc: string;
    FTitle: string;
    FDir: string;
    FOptions: TJvRunOptions;
  protected
  public
  published
    procedure Execute;override;
    property Directory:string read FDir write FDir;
    property Title:string read FTitle write FTitle;
    property Description:string read FDesc write FDesc;
    property Options:TJvRunOptions read FOptions write FOptions;
  end;

implementation

{**************************************************}
procedure TJvRunDlg.Execute;
var
  dir,tit,desc:pchar;
  opt:longint;
begin
   if FDir='' then dir:=nil else dir:=pchar(FDir);
   if FTitle='' then tit:=nil else tit:=pchar(FTitle);
   if FDesc='' then desc:=nil else desc:=pchar(FDesc);

   if roNoBrowse in FOptions then opt:=RFF_NOBROWSE else opt:=0;
   if roNoDefault in FOptions then opt:=opt or RFF_NODEFAULT;
   if roCalcDirectory in FOptions then opt:=opt or RFF_CALCDIRECTORY;
   if roNoLabel in FOptions then opt:=opt or RFF_NOLABEL;
   if roNoSeparateMem in FOptions then opt:=opt or RFF_NOSEPARATEMEM;

   SHRunFileDlg(0,Application.Icon.Handle,dir,tit,desc,opt);
end;
{**************************************************}
end.
