{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvScreenCapture.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvScreenCapture;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, extctrls, Forms;

type
  TJvScreenCapture = class(TComponent)
  private
  protected
  public
  published
    function CaptureScreen:TBitmap;
    function CaptureAreaScreen(Rec:TRect):TBitmap;
  end;

implementation

{*********************************************************}
function TJvScreenCapture.CaptureAreaScreen(Rec: TRect): TBitmap;
const
  NumColors = 256;
var
  R: TRect;
  C: TCanvas;
  LP: PLogPalette;
  Size: Integer;
  img:TImage;
begin
   img:=TImage.Create(self);
   img.Width:=rec.Right-rec.left;
   img.height:=rec.bottom-rec.top;
   R := Rec;
   C := TCanvas.Create;
   C.Handle := GetDC(HWnd_Desktop);
   try
     Img.Canvas.CopyRect(Rect(0,0,Rec.Right-Rec.left,Rec.Bottom-Rec.Top), C, R);
     Size := SizeOf(TLogPalette) + (Pred(NumColors) * SizeOf(TPaletteEntry));
     LP := AllocMem(Size);
     try
       LP^.palVersion := $300;
       LP^.palNumEntries := NumColors;
       GetSystemPaletteEntries(C.Handle, 0, NumColors, LP^.palPalEntry);
       Img.Picture.Bitmap.Palette := CreatePalette(LP^);
     finally
       FreeMem(LP, Size);
     end
   finally
     ReleaseDC(HWnd_Desktop, C.Handle);
     C.Free;
   end;
   result:=TBitmap.Create;
   Result.Assign(img.picture.bitmap);
   img.free;
end;
{*********************************************************}
function TJvScreenCapture.CaptureScreen:TBitmap;
begin
   result:=CaptureAreaScreen(Rect(0,0,Screen.width,Screen.height));
end;
{*********************************************************}
end.
