{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvTypes.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvTypes;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics;

type
  TOnUrlClick = procedure (Sender: TObject;Url:string) of object;
  TOnLinkClick = procedure (Sender: TObject;Link:string) of object;

type
  TDirection = (diBottomToTop,diLeftToRight,diRightToLeft,diTopToBottom);
  TCplApplet = function (hwndCPl: THandle; uMsg: DWORD;lParam1, lParam2: LongInt):LongInt;stdcall;
  TOnChangeKey = procedure (Sender: TObject;Rootkey:HKey;Path:string) of object;

type
  TWStatus = (wsNotAvailable,wsStopped,wsPlaying,wsPaused);
  TWinampEqualizer = record
       Bands : array[0..9] of Integer;
       Preamp:Integer;
       Enabled,Autoload:boolean;
  end;
  EWinampError = class(Exception)
  end;

type
  TGenre = (Blues,Classic_Rock,Country,Dance,Disco,Funk,Grunge,
            Hip_Hop,Jazz,Metal,New_Age,Oldies,Other,Pop,R_and_B,Rap,
            Reggae,Rock,Techno,Industrial,Alternative,Ska,
            Death_Metal,Pranks,Soundtrack,Euro_Techno,Ambient,
            Trip_Hop,Vocal,Jazz_Funk,Fusion,Trance,Classical,
            Instrumental,Acid,House,Game,Sound_Clip,Gospel,
            Noise,AlternRock,Bass,Soul,Punk,Space,Meditative,
            Instrumental_Pop,Instrumental_Rock,Ethnic,
            Gothic,Darkwave,Techno_Industrial,Electronic,
            Pop_Folk,Eurodance,Dream,Southern_Rock,Comedy,
            Cult,Gangsta,Top_40,Christian_Rap,Pop_Funk,
            Jungle,Native_American,Cabaret,New_Wave,Psychadelic,
            Rave,Showtunes,Trailer,Lo_Fi,Tribal,Acid_Punk,
            Acid_Jazz,Polka,Retro,Musical,Rock_and_Roll,
            Hard_Rock,Folk,Folk_Rock,National_Folk,Swing,
            Fast_Fusion,Bebob,Latin,Revival,Celtic,
            Bluegrass,Avantgarde,Gothic_Rock,Progressive_Rock,
            Psychedelic_Rock,Symphonic_Rock,Slow_Rock,Big_Band,
            Chorus,Easy_Listening,Acoustic,Humour,Speech,
            Chanson,Opera,Chamber_Music,Sonata,Symphony,Booty_Bass,
            Primus,Porn_Groove,Satire,Slow_Jam,Club,Tango,Samba,
            Folklore,Ballad,Power_Ballad,Rhythmic_Soul,Freestyle,
            Duet,Punk_Rock,Drum_Solo,Acapella,Euro_House,Dance_Hall,
            none);

  TId3v1Tag = packed record
     Identifier : array [0..2] of char;
     SongName   : array [1..30] of char;
     Artist     : array [1..30] of char;
     Album      : array [1..30] of char;
     Year       : array [0..3] of char;
     Comment    : array [1..30] of char;
     Genre      : TGenre;
  end;

type
  TLabelDirection=(sdLeftToRight,sdRightToLeft);
  TAngle = 0..360;
  TAppear = (apFromRight,apFromLeft,apFromTop,apFromBottom);

type
  TRegisterServiceProcess = function (dwProcessID, dwType: integer): Integer; stdcall;
const
  Wm_CallBackMessage=WM_User+1;

type
  TJvOutputMode = (omFile, omStream);
  TOnDoneFile    = procedure (Sender: TObject;FileName:string;FileSize:Integer;Url:string) of object;
  TOnDoneStream  = procedure (Sender: TObject;Stream:TStream;StreamSize:Integer;Url:string) of object;
  TOnProgress    = procedure (Sender: TObject;Position:Integer;TotalSize:Integer;Url:string;
    var Continue: Boolean) of object;
  TOnFtpProgress = procedure (Sender: TObject;Position:Integer;Url:string) of object;

const
  DBT_DEVICEARRIVAL             = $8000;
  DBT_DEVICEQUERYREMOVE         = $8001;
  DBT_DEVICEQUERYREMOVEFAILED   = $8002;
  DBT_DEVICEREMOVEPENDING       = $8003;
  DBT_DEVICEREMOVECOMPLETE      = $8004;
  DBT_DEVICETYPESPECIFIC        = $8005;
  DBT_CONFIGCHANGED             = $0018;
  DBT_DEVTYP_OEM                = $00000000;
  DBT_DEVTYP_DEVNODE            = $00000001;
  DBT_DEVTYP_VOLUME             = $00000002;
  DBT_DEVTYP_PORT               = $00000003;
  DBT_DEVTYP_NET                = $00000004;
  DBTF_MEDIA                    = $0001;
  DBTF_NET                      = $0002;
  QUERY_BROADCAST_DENY          = $424D5144;
  MaxPixelCount   =  32768;

type
   pRGBArray  =  ^TRGBArray;
   TRGBArray  =  array [0..MaxPixelCount-1] of TRGBTriple;
   TBalance = 0..100;
   TVolumeRec = record
    case byte of
     0: (LongVolume: Longint);
     1: (LeftVolume,
        RightVolume : Word);
   end;
  Tpeaks = record
       left,right:Integer;
       LeftShifted,RightShifted:Integer;
  end;

type
  TOnError       = procedure (Sender: TObject;ErrorMsg:string) of object;
  TWallpaperstyle = (wpTile,wpCenter,wpStretch);
  PDEV_BROADCAST_HDR = ^TDEV_BROADCAST_HDR;
  TDEV_BROADCAST_HDR = packed record
   dbch_size : DWORD;
   dbch_devicetype : DWORD;
   dbch_reserved : DWORD;
  end;
  PDEV_BROADCAST_VOLUME = ^TDEV_BROADCAST_VOLUME;
  TDEV_BROADCAST_VOLUME = packed record
   dbcv_size : DWORD;
   dbcv_devicetype : DWORD;
   dbcv_reserved : DWORD;
   dbcv_unitmask : DWORD;
   dbcv_flags : WORD;
  end;
  TWMDeviceChange = record
   Msg : Cardinal;
   Event : UINT;
   dwData : Pointer;
   Result : LongInt;
  end;
  TOnDeviceArrived = procedure (Sender: TObject;Drive:char) of object;
  TOnDeviceQueryRemove = procedure (Sender: TObject;Drive:char;var CanRemove:boolean) of object;
  TTransType = (ttWipeLeft,ttWipeRight,ttWipeUp,ttWipeDown,
                ttTurnLeft,ttTurnRight,ttTurnUp,ttTurnDown,
                ttWipeDownRight,ttWipeDownLeft,ttWipeUpRight,ttWipeUpLeft);
  TJvWLocation = (frFile, frResource, frRAM);
  TStars = record
       X,Y:Integer;
       Color:TColor;
       Speed:Integer;
  end;
  TJoyCap = (joHasZCoordinate,joHasRudder,joHasUCoordinate,joHasVCoordinate,joHasPointOfVue,
           joHasPointOfVDiscrete,johasPointOfVContinuous);
  TJoyCaps = set of TJoyCap;
  TJoyButtonDown = procedure (Sender: TObject;X,Y:Integer;ButtonChanged:Integer;But1Pressed,But2Pressed,But3Pressed,But4Pressed:boolean) of object;
  TJoyMove = procedure (Sender: TObject;X,Y:Integer;But1Pressed,But2Pressed,But3Pressed,But4Pressed:boolean) of object;
  TJoyZMove = procedure (Sender: TObject;Z:Integer;But1Pressed,But2Pressed,But3Pressed,But4Pressed:boolean) of object;
  TErrorMsg = procedure (Sender: TObject;code:Integer;Msg:string) of object;
  TBright = 0..200;

type
  TPopupPosition = (ppNone, ppForm, ppApplication);
  TJvDirMask = (dmFileNameChange, dmDirnameChange, dmAttributesChange, dmSizeChange, dmLastWriteChange, dmSecurityChange);
  TJvDirMasks = set of TJvDirMask;
  EJvDirectoryError = class(Exception);
  TListEvent = procedure (Sender: TObject;Title:string;Handle:THandle) of object;

type
  TOnPrnProgress = procedure (Sender: TObject;Current,Total:integer) of object;
  TOnNextp = procedure (Sender: TObject;PageNumber:integer) of object;
  TBitmapstyle = (bsNormal,bsCentered,bsStretched);

type
  TOnOpened = procedure (Sender: TObject;Value:string) of object;
  TOnOpenCanceled = procedure (Sender: TObject) of object;

type
  TOnKeyFound=procedure(Sender: TObject;Key,Results,OriginalLine:string) of object;
  TParserInfos = TstringList;
  TParserInf = class
               StartTag,EndTag:string;
               MustBe,Take:Integer;
  end;

const
   cr=#13#10;

type
  TGradstyle = (grFilled,grEllipse,grHorizontal,grVertical,grPyramid,grMount);
  TOnDelete = procedure (Sender: TObject;Path:string) of object;
  TOnParent = procedure (Sender: TObject;ParentWindow:THandle) of object;
  TOnImage = procedure (Sender: TObject;Image:TBitmap) of object;
  TOnText = procedure (Sender: TObject;Text:string) of object;
  TJvCommPort = (cpNOCOM,cpCOM1,cpCOM2,cpCOM3,cpCOM4,cpCOM5,cpCOM6,cpCOM7,cpCOM8);
  TJvRestart = (rsLogoff, rsShutdown, rsReboot, rsRestart, rsRebootSystem, rsExitAndExecApp);
  TJvRunOption = (roNoBrowse, roNoDefault, roCalcDirectory, roNoLabel, roNoSeparateMem);
  TJvRunOptions = set of TJvRunOption;
  TJvFileType = (ftFile, ftPrinter);

const
  SHFMT_ID_DEFAULT                         = $FFFF;
  SHFMT_OPT_QUICKFORMAT                    = $0000;
  SHFMT_OPT_FULL                           = $0001;
  SHFMT_OPT_SYSONLY                        = $0002;
  SHFMT_ERROR                              = -1;
  SHFMT_CANCEL                             = -2;
  SHFMT_NOFORMAT                           = -3;

type
  TSHFormatDrive = function (Handle: HWND; Drive, ID, Options: Word): LongInt;stdcall;
  TFormatOption = (shQuickFormat,shFull,shSystemFilesOnly);
  TButtonstyle = (bsAbortRetryIgnore,bsOk,bsOkCancel,bsRetryCancel,bsYesNo,bsYesNoCancel);
  TButtonDisplay = (bdIconExclamation,bdIconWarning,bdIconInformation,bdIconAsterisk,
                 bdIconQuestion,bdIconStop,bdIconError,bdIconHand);
  TDefault = (dbButton1,dbButton2,dbButton3,dbButton4);
  TModality = (bmApplModal,bmSystemModal,bmTaskModal);
  TButtonOption = (boDefaultDesktopOnly,boHelp,boRight,boRtlReading,boSetForeground,boTopMost);
  TButtonOptions = set of TButtonOption;
  TButtonResult=(brAbort,brCancel,brIgnore,brNo,brOk,brRetry,brYes);
  TMstyle = (msBeep,msIconAsterisk,msIconExclamation,msIconHand,msIconQuestion,msOk);
  TDiskRes = (dsSuccess,dsCancel,dsSkipfile,dsError);
  TDiskstyle = (idfCheckFirst,idfNoBeep,idfNoBrowse,idfNoCompressed,idfNoDetails,
             idfNoForeground,idfNoSkip,idfOemDisk,idfWarnIfSkip);
  TDiskstyles = set of TDiskstyle;
  TDeletestyle = (idNoBeep,idNoForeground);
  TDeletestyles = set of TDeletestyle;
  TOnOk = procedure (Sender: TObject;Password:string;var Accept:boolean) of object;

const
  TVIS_CHECKED            = $2000;

Const
  CPL_DBLCLK = 5;
  Oper=120*pi/180;

type
  TCoordChanged = procedure (Sender: TObject;Coord:string) of object;
  TNotifyEventParams=procedure(Sender : TObject; params : pointer) of object;
  TFileInformation = record
                   Attributes:DWord;
                   DisplayName:string;
                   ExeType:Integer;
                   Icon:HIcon;
                   Location:string;
                   TypeName:string;
                   SysIconIndex:Integer;
  end;
  TJvAnimations = (anLeftRight,anRightLeft,anRightAndLeft,anLeftVumeter,anRightVumeter);
  TJvAnimation = set of TJvAnimations;
  TDropEvent = procedure(Sender: TObject;Pos:TPoint;Value:TstringList)of object;
  TOnFound = procedure (Sender: TObject;Path:string) of object;
  TOnChangedDir = procedure (Sender: TObject;Directory:string) of object;
  TOnAlarm = procedure (Sender: TObject;Keyword:string) of object;
  TAlarm = record
         Keyword:string;
         DateTime:TDateTime;
  end;

type
  TOnChangeColor = procedure (Sender: TObject;Foreground,Background:TColor) of object;


implementation

end.
